#include<string.h>
#include<stdlib.h>
#include "funktionen.h"

char sucheBefehl[ ][10]={"NOP0","NOP1",
                         "SPA","SPB","BEB","BEA","STS","STP","KEW","KZW",
                         "SLW","SRW","ADD","TAK","XOW","DUF","DEF","!=F","><F",">=F","<=F",
                         "UN","ON","U(","O(","SI","SV","SE","SS","SA",
                         "ZV","ZR","FR","+F","-F","*F","/F","<F",">F",
                         "BE","UW","OW","LC",
                         "U","O",")","R","S","=","L","T","D","I","\r"};

char sucheOperand[ ][10]={"AB","EB","MB","AW","EW","MW",
                          "KB","KF","KH","KM","KY","KT","KZ",
                          "PB","FB","SB","OB","BF",
                          "E","A","M","T","Z","=","\x0D"};


bool NurLeerzeichen(const char* pfirst,const char* psecond)
{    int len,len2=0;
     len=psecond-pfirst;
     if(len>0)
       len2=strspn(pfirst,"\x20\t");  // prfen ob auf nur Leerzeichen
     if(len==0 ||  len==len2)
        return true;
     else
        return false;
}

int strspn_abZeichen(char *pStr,char *AbZeichen, char *Zeichen)
{  int n=0;
   pStr=strpbrk(pStr,AbZeichen);
   if (pStr)
   {  pStr++;
      n=strspn(pStr,Zeichen);
   }
   return n;
}

char* FindStr(const char *Str,const char *SuchStr)
{  static char sStr[80],*pStr;
   strcpy(sStr,"|");
   strcat(sStr,SuchStr);
   strcat(sStr,"|");
   pStr=strstr(Str,sStr);
   if(pStr)
      return (pStr+1);
   else
      return 0;
}

char *AnfangSuchen(const char *pAnfang,const char *AnfangsZeichen)
{ char *pAnfangWert;
  pAnfangWert=strpbrk(pAnfang,AnfangsZeichen); //Erlaubte Anfangszeichen
  if(pAnfangWert)
  {  if(NurLeerzeichen(pAnfang,pAnfangWert))
         return  pAnfangWert;
     else
         return NULL;
   }
   return NULL;
}

int PruefenUndFormatieren(char *Str)
{   char *pAnfang,*pEndeStr;
    char *pAnfangLabel,*pEndeLabel,Label[10];
    char *pAnfangBefehl,Befehl[10];
    char *pAnfangOperand,Operand[10];
    char *pAnfangWert,zwWert[40],Wert[40];
    char *pKomentarMerken,KomentarMerken[80];
	 int   lenWert,StrLen,ZeichLen;
    char  zwCStr[80],CStr[80];
    int   n;
    int   unsigned FehlerBits;
    int   NichtGefunden;
    bool  NurKomentar=false;
	//memset(CStr,0,80);
    *Label=0;
    *Befehl=0;  //l�chen
    *Operand=0; //L�chen
    *Wert=0;    //l�chen
    FehlerBits=0;
    //Trim(Str);
    if(*Str==0) goto Ausgabe;
	 
	 *KomentarMerken=0;
	 strcpy(zwCStr,Str);
	 pKomentarMerken=strchr(zwCStr,'$');
	 if (pKomentarMerken)
	 {  strcpy(KomentarMerken,pKomentarMerken);
	 	 pEndeStr=pKomentarMerken;
		*pEndeStr=0;
		 pEndeStr-=1;
	 }
	 else
	 	 pEndeStr=strchr(zwCStr,0)-1;
	 Trim(zwCStr);
	 pAnfang=zwCStr;
    if(*pAnfang==0)
	 { NurKomentar=true;
	 	goto Ausgabe;
	 }	
	// printf("Str:%s|#|Komentar:%s\n",pAnfang,KomentarMerken);
	 //*********************** Auf Label Prfen ********************
    pEndeLabel=strchr(pAnfang,':');
    if(pEndeLabel)
    {  pAnfangLabel=AnfangSuchen(pAnfang,"ABCDEFGHIJKLMNOPQRSTUVWXYZ");
       if(pAnfangLabel)
       {  StrLen=pEndeLabel-pAnfangLabel+1;
          strncpy(Label,pAnfangLabel,StrLen); Label[StrLen]=0;
          if(*pEndeLabel==0)
				 goto Ausgabe;
			 pAnfang=pEndeLabel+1;
       }
    }
    // *********************** Befehl *****************************
    pAnfangBefehl=AnfangSuchen(pAnfang,"UO)SR=LTZF+-*/!><BKADIXN");
    if(pAnfangBefehl)
    {    NichtGefunden=1;
         n=0;
         int lenBefehl=0;
         char *pTimer=strchr(pAnfangBefehl,'T');
         while(strcmp("\r",sucheBefehl[n]) && NichtGefunden)
         {   lenBefehl=strlen(sucheBefehl[n]);
             if(lenBefehl==1)
               NichtGefunden=strncmp(pAnfangBefehl,sucheBefehl[n],1);
             else if(lenBefehl==2)
               NichtGefunden=strncmp(pAnfangBefehl,sucheBefehl[n],2);
             else if(lenBefehl==3)
                NichtGefunden=strncmp(pAnfangBefehl,sucheBefehl[n],3);
             else if(lenBefehl==4)
                NichtGefunden=strncmp(pAnfangBefehl,sucheBefehl[n],4);
             if(!NichtGefunden)
             {  if(FindStr("|SE|SA|",sucheBefehl[n]) && !pTimer)
                   NichtGefunden=1;
                else
                {   strcpy(Befehl,sucheBefehl[n]);
                   // BefehlErmittelt=true;
                }
             }
             n++;
          } //ENDE while
    }
    else //if(!pAnfangBefehl)
    { FehlerBits|=1;
      goto Ausgabe;
    }
//Befehle ohne Operanden und Wert
     if(FindStr("|NOP0|NOP1|!=F|><F|>=F|<=F|BEB|BEA|STS|STP|XOW|KEW|KZW"
                "|SLW|SRW|TAK|XOW|DUF|DEF|UW|OW|U(|O(|)|+F|-F|*F|/F|>F|<F|BE|D|I|",Befehl))
        goto Ausgabe;
	 
	

//*********************** Operand ****************************
    if(pAnfangBefehl)
       pAnfang=pAnfangBefehl+strlen(Befehl);
    else
    {  FehlerBits|=2;
       goto Ausgabe;
    }
    
	 pAnfangOperand=AnfangSuchen(pAnfang,"EAMTZ");  
    if(!strcmp(Befehl,"O") && pAnfangOperand==NULL) // wenn nur oder
	 	goto Ausgabe; 
	 
	 
	 if(pAnfang>pEndeStr)
    {    FehlerBits|=2;
         goto Ausgabe;
    }
    
	 pAnfangOperand=AnfangSuchen(pAnfang,"EAMTZKPFSOB=");// = bei z.B. SPA  =  Marke
	 
	 if(pAnfangOperand)
    {  NichtGefunden=1;
       n=0;
       int lenOperand=0;
       while(strcmp("\r",sucheOperand[n]) && NichtGefunden)
       {  lenOperand=strlen(sucheOperand[n]);
          if(lenOperand==1)
             NichtGefunden=strncmp(pAnfangOperand,sucheOperand[n],1);
          else if(lenOperand==2)
             NichtGefunden=strncmp(pAnfangOperand,sucheOperand[n],2);
          else if(lenOperand==3)
             NichtGefunden=strncmp(pAnfangOperand,sucheOperand[n],3);
          if(NichtGefunden)
             n++;
          else
            strcpy(Operand,sucheOperand[n]);
       }
    }
    else
    { FehlerBits|=2;
      goto Ausgabe;
    }


//************************* Wert ************************
  if(pAnfangOperand)
     pAnfang=pAnfangOperand+strlen(Operand);
  else
  {  FehlerBits|=4;
     goto Ausgabe;
  }
  if(pAnfang>pEndeStr)
  {    FehlerBits|=4;
       goto Ausgabe;
  }
  if(!strcmp(Operand,"="))  
  {	pAnfangWert=AnfangSuchen(pAnfang,"ABCDEFGHIJKLMNOPQRSTUVWXYZ");
  		if(!pAnfangWert)
  		{  FehlerBits|=4;
     		goto Ausgabe;
  		}
		lenWert=strspn(pAnfangWert,"ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");
      strncpy(Wert,pAnfangWert,lenWert);
		Wert[lenWert]=0;
  	   goto Ausgabe;
  
  
  }
  
  pAnfangWert=AnfangSuchen(pAnfang,"+-0123456789ABCDEF");
  if(!pAnfangWert)
  {  FehlerBits|=4;
     goto Ausgabe;
  }
  
  
  lenWert=strspn(pAnfangWert,"+-,.0123456789ABCDEF");
  ZeichLen=strlen(pAnfangWert);
  if(lenWert!=ZeichLen)
  {   FehlerBits|=4;
      goto Ausgabe;
  }
  else
     strcpy(zwWert,pAnfangWert);
// Werte auf Richtigkeit prfen
  if(FindStr("|E|M|A|",Operand))
  {  if(ZahlOk(zwWert,".0123456789"))
     {  strcpy(Wert,zwWert);
        if(!WerteBereich_PK(Wert,0,255,'.',0,7)) FehlerBits|=4;
     }
     else FehlerBits|=4;
  }
  else if(!strcmp(Operand,"T") || !strcmp(Operand,"Z"))
  {  if(ZahlOk(zwWert,"0123456789"))
     {   strcpy(Wert,zwWert);
         if(!WerteBereich(Wert,0,255,10)) FehlerBits|=4;
     }
     else FehlerBits|=4;
  }
  else if(strcmp(Operand,"KB")==0)
  {  if(ZahlOk(zwWert,"0123456789"))
     {  strcpy(Wert,zwWert);
        if(!WerteBereich(Wert,0,255,10)) FehlerBits|=4;
     }
     else FehlerBits|=4;
  }
  else if(strcmp(Operand,"KF")==0)
  {  if(ZahlOk(zwWert,"+-0123456789"))
     {  strcpy(Wert,zwWert);
        if(!WerteBereich(Wert,-32768,32767,10)) FehlerBits|=4;
     }
     else FehlerBits|=4;
  }
  else if(strcmp(Operand,"KH")==0)
  {  if(ZahlOk(zwWert,"0123456789ABCDEF"))
     {  strcpy(Wert,zwWert);
        if(!WerteBereich(Wert,0,65535,16)) FehlerBits|=4;
     }
     else FehlerBits|=4;
  }
  else if(strcmp(Operand,"KM")==0)
  {   if(ZahlOk(zwWert,"01"))
      {  strcpy(Wert,zwWert);
         if(!WerteBereich(Wert,0,65535,2)) FehlerBits|=4;
      }
      else FehlerBits|=4;
  }
   else if(strcmp(Operand,"KY")==0)
  {   if(ZahlOk(zwWert,",0123456789"))
      {  strcpy(Wert,zwWert);
         if(!WerteBereich_PK(Wert,0,255,',',0,255)) FehlerBits|=4;
      }
      else FehlerBits|=4;
  }
  else if(strcmp(Operand,"KT")==0)
  {   if(ZahlOk(zwWert,".0123456789"))
      {  strcpy(Wert,zwWert);
         if(!WerteBereich_PK(Wert,1,999,'.',0,3)) FehlerBits|=4;
      }
      else FehlerBits|=4;
  }
  else if(strcmp(Operand,"KZ")==0)
  {  if(ZahlOk(zwWert,"0123456789"))
     {  strcpy(Wert,zwWert);
        if(!WerteBereich(Wert,0,999,10)) FehlerBits|=4;
     }
     else FehlerBits|=4;
  }
  else if(FindStr("|OB|PB|FB|SB|",Operand))
  {  if(ZahlOk(zwWert,"0123456789"))
     {   strcpy(Wert,zwWert);
         if(!WerteBereich(Wert,1,255,10)) FehlerBits|=4;
     }
     else FehlerBits|=4;
  }
  else if(FindStr("|EB|MB|AB|EW|MW|AW|",Operand))     //Neu
  {   if(ZahlOk(zwWert,"0123456789"))
      {  strcpy(Wert,zwWert);
         if(!WerteBereich(Wert,0,255,10)) FehlerBits|=4;
      }
      else FehlerBits|=4;
  }
  else  FehlerBits|=2;


Ausgabe:
  if(FehlerBits==0)
  {   if(NurKomentar)
 		{  strcpy(CStr,KomentarMerken); 
      }
		else
		{	strcpy(CStr,Label);
			strcat(CStr,"\t");
			strcat(CStr,Befehl);
			strcat(CStr,"\t");
			strcat(CStr,Operand);
			strcat(CStr,"\t");
			strcat(CStr,Wert);
			if(pKomentarMerken) 
			{	strcat(CStr,"\t");
				strcat(CStr,KomentarMerken); 
			}
		}
		strcpy(Str,CStr); // Str <--<< CStr    Ausgabe
   }
	return FehlerBits;
}
