/***************************************************************************
 *   Copyright (C) 2004 by Burkhard Brauer                                 *
 *   BurkhardBrauer@t-online.de                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "ksps.h"
#include <kpopupmenu.h>
#include <qlabel.h>
#include <kmainwindow.h>
#include <klocale.h>
#include <kapp.h>
#include <kmainwindow.h>
#include <kled.h>
#include <qfont.h>
#include <qstatusbar.h>
#include <qmultilinedit.h>
#include <qtextedit.h>
#include <qlineedit.h>
#include <qtimer.h>
#include <qdatetime.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qtable.h>
#include <kmenubar.h>
#include <qfiledialog.h>
#include <qstring.h>
#include <qlineedit.h>
#include <qspinbox.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qcombobox.h> 
#include <qwidget.h>
#include <qpainter.h>
#include <qstring.h>
#include <ctype.h>
#include <iostream>
#include <stdio.h>
#include <unistd.h>
#include <qscrollbar.h>
#include <qrect.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <qpushbutton.h>
#include <klocale.h>
#include <qapplication.h>
#include <qtable.h>
#include <qheader.h>
#include <qslider.h>
#include <qlcdnumber.h>
#include <qmessagebox.h> 
#include <qframe.h> 
#include <kmenubar.h>
#include <qthread.h>

#include <unistd.h>

#include <time.h>       // fuer time(),localtime() und strftime()
#include <stdio.h>
#include <stdlib.h>
#include <stdlib.h>
#include <math.h>
#include "ksps.moc"
//******************#include "sps.moc"
#include "konstanten.h"
#include "funktionen.h"
#include "befehle_erkennen.h"
#include "cpu_sps.h"
#include "compiler.h"

#include "ttySn.h"
#include "funktionen.h"

extern QString data_path;
extern QString DateiFilter;

extern	Baustein_Infos	*OB_Infos;
extern	Baustein_Infos	*PB_Infos;
extern	Baustein_Infos *FB_Infos;
extern	Baustein_Infos *SB_Infos;
extern int Status_BausteinName,Status_BausteinNr,Status_Netzwerk_Nr;	
extern char Befehle[BEREICH_BE_TY][LAENGE_STR];
extern char Typen [BEREICH_BE_TY][LAENGE_STR];
extern int  BefehlAnzahlParameter[1025];
extern	StruturCode *BCode;
extern	StruturCode *Code;
extern	StruturCode StCode;
extern	StruturCode *OB_Zeiger[256],*PB_Zeiger[256],*FB_Zeiger[256],*SB_Zeiger[256];
extern   StructBefehle *BefehleStack;
extern	bool StatusAnzeigen;
extern   StructProzess *ProzessStack;
extern	int ProzessPointer;
char msStr[80]; 
char  FehlerMeldung[11][80];
ksps *pksps;
CPU_sps* CPU= new CPU_sps();
QString  ProjektHomePath,homePath;
QDir path;
	
KApplication* app;


QMessageBox *MessageBox;
QButtonGroup *pSliderBox;
QSlider *slider;
QLCDNumber *lcd;
QListBox *FehlerListBox;
QMultiLineEdit *Editor;
QPainter pMaler;
KMenuBar *menu;
QPopupMenu *MenuProjekt,*MenuText, *MenuBearbeiten,*MenuAG;

QFrame *pRahmen;
QLabel *Marke_lbl, *Befehl_lbl, *Operand_lbl, *BitNummerWert_lbl,*Inhalt_lbl,
			 *Vek_lbl, *Akku1_2Komentar_lbl, *Akku2_lbl;

QStatusBar *statusbar;
QString QStr;
QString QBausteinName;
QLabel *statusBausteinUeberschrift_Lbl,*statusNetzwerkUeberschrift_Lbl;
QLabel *EditorNetzwerkUeberschrift_lbl,*EditorBausteinUeberschrift_lbl;
QLabel *Label_ABit[256];

QPushButton *neuesNetzwerkBtn;
QPushButton *einfuegenNetzwerkBtn;
QPushButton *loescheNetzwerkBtn;

QTimer *ms10Timer,*AnzeigeTimer,*SimulationsTimer;
QScrollBar* ScrollBarVer;
QComboBox *ComboBox,*ComboBox_ttySn;

QButtonGroup *ButtonGroupEB0;
QButtonGroup *ButtonGroupEB1;
QButtonGroup *ButtonGroupEB2;
QButtonGroup *ButtonGroupEB3;

QFrame *Frame_EBit[256];
QPushButton *PushButton_EBit[256],*PauseButton;
QLineEdit *LEdit_EBit[256];
QLineEdit *LEdit_Conuter;
KLed *LED_EBit[256];
QLabel *Label_EBit[256];

QFrame *Frame_ABit[256];
QLineEdit *LEdit_ABit[256];
KLed *LED_ABit[256];

QLineEdit *Bau_Nr_Edit,*Bau_NetzwerkNr_Edit;
QLineEdit *BausteinTitelEditor,*NetzwerkTitelEditor;
QSpinBox *spinBoxStatus_NE_Nr;
int status_spinBox_AlteNetzwerkNr=0;
QSpinBox *spinBox_text_NeNr;
QButtonGroup *ButtonGroupAB0;
QButtonGroup *ButtonGroupAB1;

QButtonGroup *pButtonGroupRunStop_Rb;
QRadioButton *pAgRun_Rb,*pAgStop_Rb;

QButtonGroup *pButtonGroupHexDez_Rb;
QRadioButton *pDez_Rb,*pHex_Rb,*pKommentar_Rb;

QButtonGroup *pButtonGroupRS232_Rb;


QTabWidget *TabWidget;
QWidget *pStatusAusgabeFenster,*pEditorWidget,*pStatusWidget,*pZuordnungslisteWidget;
QListBox *ListBox;
QLabel *Label_ListBox;

QListBox *TestListe;

QTable *pTabelle;
QHeader 	*hHeader;
QTable 	*pEAM_KommentarTabelle,*pTZ_ObPbFbSbKommentarTabelle;
QHeader 	*hHeaderEAM_KommentarTabelle,*vHeaderEAM_KommentarTabelle;
QHeader	*hHeaderTZ_ObPbFbSbKommentarTabelle,*vHeaderTZ_ObPbFbSbKommentarTabelle;

QFileDialog *fileName;
QColor grau (160,160,160);
QFont statusfont ("courier",12, QFont::Bold);

unsigned char AB_staticFarbe[256];

enum Wahl_StatusAnzeigeAkku{DEZ=1,HEX,KOMMENTAR};
int AkkuDarstellung=DEZ;

unsigned int Code_Anzahl=0;
int StackPointer=0;

int MaxTextNetzwerkNr=0;
int BausteinName=0,BausteinNr=0,TextNetzwerkNr=0,i_Adresse=0,i_returnStack=0;
short returnWert=0;
int BefehlsPointer=0;
bool Ausgabe_geaendert=true;


QString QProjektpfadPlusProjektname="./";
QString QProjektpfad="./";
QString QProjektname="";
QString QDateipfadPlusDateiname="./";
QString QDateipfad="./";
QString QDateiname="";
const char *PROJEKT_KENNUNG="ksps_Projekt>";
char Projekt_Kennung[81]="",ProjektNameStr[81]="",DatumStr[81]="",UhrzeitStr[81]="",AutorStr[81]="";
bool	TextBausteinVorhanden=false;

const int	MARKE_SP=0;
const int   OPERAND_SP=MARKE_SP+60;
const int   TYPE_SP=OPERAND_SP+45;
const int   PARA_SP=TYPE_SP+45;
const int   INHALT_SP=PARA_SP+170;
const int	STATUS_SP=INHALT_SP+68;
const int	AKKU1_SP=STATUS_SP+40;//35;55
const int	AKKU2_SP=AKKU1_SP+70;
const int	Kommentar_SP=STATUS_SP+35;
int offsetZeile=0;
short showRun=0;
bool NeuenStatusAnzeigen_vonThread=false;
struct Ausgabe_Str
{	bool Aktiv;
	char Marke[7];
	char Befehl[6];
	char Operand[9];
	char Wert[19];
	char Inhalt[8];
	char Vek[2];
	char Akku1[8];
	char Akku2[8];
	char EAMTZ_Kommentar[32];
};

Ausgabe_Str * AusgabeStatus= new Ausgabe_Str[AUSGABE_STR_ANZ];

int ComboBox_AlterIndex=0;
int SimulationAlle_ms=50;
int altSimulationAlle_ms=50;

using namespace std;

bool SPS_RUN=false;

char **pText;
char *pBausteinUeberschrift=NULL;


//--------------------- milliSekunden Counter ---------------------------------------------------

char CounterCStr[80];
double miliSekunden_double=0;


class My_msCounterThread : public QThread
{private:
  QTime Counter;
  bool running;
  unsigned int miliSekunden,miliSekunden_Alt;
  double plus,msCounter64Bit;  
public:	
  double GetTickCounter(void);  
  void stop(void);  
  virtual void run();
};


void  My_msCounterThread::run()
{	Counter.start();	
	miliSekunden_Alt=miliSekunden=Counter.elapsed();
	plus=0.0;
	running=true;

	while(running)
	{ miliSekunden=Counter.elapsed();
	  if(miliSekunden_Alt>miliSekunden)
	  {	plus+=86400000;
	  }
     miliSekunden_Alt=miliSekunden;
	  msCounter64Bit=plus+(double)miliSekunden;
	  msleep(1);
	}
}//ENDE My_msCounterThread::run()

inline double My_msCounterThread::GetTickCounter(void)
{	return msCounter64Bit; 
}//ENDE My_msCounterThread::GetTickCounter(void)

void My_msCounterThread::stop(void) 
{ running=false;
}

My_msCounterThread ms;

//-------------------------------- WorkThread 



class MyWorkThread : public QThread
{	public:
  	char Str1[80];
  	bool running,aktiv;	
  	void stop(void);  
	virtual void run();
};

#define BAUTRATE B38400
ttySn *ttySx;
char ADaten[10]={0,0,0}; 
char &PortA=ADaten[0];
char &PortC=ADaten[1];
char EDaten[10]={0,0,0};
char &PortB=EDaten[0];
char &PortD=EDaten[1];


bool RS232_Aktive=false;
char n;
void  MyWorkThread::run()
{ aktiv=false;
  running=true;
  while(running)
  {	NeuenStatusAnzeigen_vonThread=false;
		if(aktiv)
		{  miliSekunden_double=ms.GetTickCounter();
         // Eingänge einlesen
			if(RS232_Aktive)
			{	ttySx->Senden("T",1);				//Interface zum Senden auffordern
				ttySx->Empfangen(EDaten,2);		//Intefaceeingänge lesen
			}
			else
			{	PortB=PortD=0;
			
			}
			pksps->EB_Port[2]=PortB; 			//PortB = EDaten[0]
			pksps->EB_Port[3]=PortD; 			//PortD = EDaten[1]
			CPU->EByte[2]=pksps->EB_Port[2];
			CPU->EByte[3]=pksps->EB_Port[3];
			
			pksps->SPS_ProgrammAufrufen(); // SPS Programm bearbeiten
		
			// Ausgänge ausgeben
			PortA=CPU->AByte[0];					//PortA = ADaten[0]
			PortC=CPU->AByte[1];					//PORTC = ADaten[1]
			pksps->AB_Port[0]=CPU->AByte[0];
			pksps->AB_Port[1]=CPU->AByte[1];
			if(RS232_Aktive)
			{	ttySx->Senden("R",1);				//Interface zum Empfangen auffordern
				ttySx->Senden(ADaten,2);			//Interfaceausgänge beschreiben
   		}
			NeuenStatusAnzeigen_vonThread=true;
		}
		msleep(10);//SimulationAlle_ms);
   }
}//Ende MyWorkThread::run()

void  MyWorkThread::stop(void)
{  running=false;
}

MyWorkThread WorkThread;

ksps::ksps() :  KMainWindow( 0, "ksps" )
{// set the shell's ui resource file
 //setXMLFile("kspsui.rc");
	int n,i,Zeile,Spalte,Offset,x;
	int Ergebnis,Rest;
	char CStr[256];
  	pksps=this;
	ProjektHomePath=path.homeDirPath();
	homePath=path.homeDirPath(); 
//*************	cout << ProjektHomePath <<"\n";
//*************	cout << homePath <<"\n";
	Code_Anzahl=0;
	StackPointer=0;
	BefehlsPointer=0;
	MaxTextNetzwerkNr=0;
	BausteinName=0;
	BausteinNr=0;
	TextNetzwerkNr=0;
	i_Adresse=0;
	i_returnStack=0;
   returnWert=0;
	Ausgabe_geaendert=true;
	ComboBox_AlterIndex=0;
	//pOB_NetzwerkUeberschrift[256][256];
	pOB_NetzwerkUeberschrift=new char**[256];	
	pPB_NetzwerkUeberschrift=new char**[256];	
	pFB_NetzwerkUeberschrift=new char**[256];	
	pSB_NetzwerkUeberschrift=new char**[256];
	pOB_BausteinUeberschrift=new char*[256];
	pPB_BausteinUeberschrift=new char*[256];
	pFB_BausteinUeberschrift=new char*[256];
	pSB_BausteinUeberschrift=new char*[256];
	Netzwerk_Text=new char*[256];
	pEingaenge_Kommentar=new char*[256];
	pAusgaenge_Kommentar=new char*[256];
	pMerker_Kommentar=new char*[256];
	pTimer_Kommentar=new char*[256];
	pZaehler_Kommentar=new char*[256];
	pOB_Kommentar=new char*[256];
	pPB_Kommentar=new char*[256];
	pFB_Kommentar=new char*[256];
	pSB_Kommentar=new char*[256];
	CStr_zwischenSpeicher=new char[ANZAHL_CHAR];
	for(n=0;n<=255;n++)
   {	OB_Zeiger[n]=NULL;
		PB_Zeiger[n]=NULL;
		FB_Zeiger[n]=NULL;
		SB_Zeiger[n]=NULL;
		pOB_BausteinUeberschrift[n]=NULL;
		pPB_BausteinUeberschrift[n]=NULL;
		pFB_BausteinUeberschrift[n]=NULL;
		pSB_BausteinUeberschrift[n]=NULL;
		pOB_NetzwerkUeberschrift[n]=new char*[256];	
		pPB_NetzwerkUeberschrift[n]=new char*[256];	
		pFB_NetzwerkUeberschrift[n]=new char*[256];	
		pSB_NetzwerkUeberschrift[n]=new char*[256];
		for(i=0;i<256;i++)
		{	pOB_NetzwerkUeberschrift[n][i]=NULL;
			pPB_NetzwerkUeberschrift[n][i]=NULL;
			pFB_NetzwerkUeberschrift[n][i]=NULL;
			pSB_NetzwerkUeberschrift[n][i]=NULL;
		}
		Netzwerk_Text[n]=NULL;
	 	Anzahl_Netzwerk_Speicher[n]=0;
		pEingaenge_Kommentar[n]=new char[80];
		*pEingaenge_Kommentar[n]=0;
		pAusgaenge_Kommentar[n]=new char[80];
		*pAusgaenge_Kommentar[n]=0;
		pMerker_Kommentar[n]=new char[80];
		*pMerker_Kommentar[n]=0;
		pTimer_Kommentar[n]=new char[80];
		*pTimer_Kommentar[n]=0;
		pZaehler_Kommentar[n]=new char[80];
		*pZaehler_Kommentar[n]=0;
		pOB_Kommentar[n]=new char[80];
		*pOB_Kommentar[n]=0;
		pPB_Kommentar[n]=new char[80];
		*pPB_Kommentar[n]=0;
		pFB_Kommentar[n]=new char[80];
		*pFB_Kommentar[n]=0;
		pSB_Kommentar[n]=new char[80];
		*pSB_Kommentar[n]=0;
	}//ENDE 	for(n=0;n<256;n++)
	SPS_RUN=false;
	for(n=0; n<=255; n++)
	{	CPU->EByte[n]=0;
	   CPU->AByte[n]=0;
		EB_Port[n]=0;
		AB_Port[n]=0;
	}
	TextBausteinVorhanden=false;
	memset(AB_staticFarbe,0,sizeof(char)*256);
	memset(CStr_zwischenSpeicher,0,sizeof(char)*ANZAHL_CHAR);
	memset(OB_Infos,0,sizeof(Baustein_Infos)*AnzahlBausteine);
	memset(PB_Infos,0,sizeof(Baustein_Infos)*AnzahlBausteine);
	memset(FB_Infos,0,sizeof(Baustein_Infos)*AnzahlBausteine);
	memset(SB_Infos,0,sizeof(Baustein_Infos)*AnzahlBausteine);
	*DatumStr = 0;
	*UhrzeitStr = 0;
	*AutorStr = 0;
	*Projekt_Kennung = 0;
	*ProjektNameStr = 0;
	*DatumStr = 0;
	*UhrzeitStr = 0;
	*AutorStr = 0;
	MaxTextNetzwerkNr = 0;
	setGeometry(0, 0, BILD_BREITE,BILD_HOEHE);
	setMinimumSize(BILD_BREITE, BILD_HOEHE);
	setMaximumSize(BILD_BREITE, BILD_HOEHE);
	setBackgroundColor(grau);
	ZeichnungPuffer.resize(1024,735);
	ZeichnungPuffer.fill(black);
 	Status_BausteinName=OB;
 	Status_BausteinNr=1;
 	Status_Netzwerk_Nr=1;
	MenuProjekt =new QPopupMenu();
	MenuProjekt->insertItem(i18n("Lade Projekt"),M_POJEKT_LADEN);
   MenuProjekt->insertItem(i18n("Speichere Projekt Daten"),M_PROJEKT_DATEN_SPEICHERN);
	MenuProjekt->insertItem(i18n("Neues Projekt"),M_NEUES_PROJEKT);
	MenuProjekt->insertItem(i18n("Lade das Projekt und alle Bausteine ins AG und starte es."), 																	M_POJEKT_LADEN_U_START);
	MenuProjekt->insertItem(i18n("Lade Beispielprojekt und alle Bausteine ins AG und starte es."), 															M_BEISPIEL_POJEKT_LADEN);
	MenuProjekt->insertItem(i18n("ENDE (Schiesse Programm)"),M_QUIT);
	MenuText =new QPopupMenu();
	MenuText->insertItem(i18n("Lade Text Baustein"),M_TEXT_LADEN);
	MenuText->insertItem(i18n("Speichere Text Baustein"),M_TEXT_SPEICHERN);
	MenuText->insertItem(i18n("Speichere Textbaustein als"),M_TEXT_SPEICHERN_ALS);
	MenuText->insertItem(i18n("Erzeuge Baustein"),M_NEUER_BAUSTEIN);
	MenuText->setDisabled(true);
  //------------------------------------------------------
	MenuBearbeiten=new QPopupMenu();
	MenuBearbeiten->insertItem(i18n("Formatiere den Text [F2]"),M_FORMATIEREN);
	//MenuBearbeiten->insertItem(i18n("Auf Fehler Pruefen	[F3]"),M_FEHLER_PRUEFEN);
	//-------------------------------------------------------
	MenuAG =new QPopupMenu();
	MenuAG->insertItem(i18n("Uebertrage Baustein zum AG"),M_BAUSTEIN_TRANSVER);
  	MenuAG->insertItem(i18n("Uebertrage alle Bausteine zum AG"),M_ALLE_BAUSTEINE_TRANSVER);
	MenuAG->insertItem(i18n("AG Neustart"),M_AG_NEUSTART);
	MenuAG->insertItem(i18n("Loesche alle Bausteine im AG"),M_AG_LOESCHEN);
	MenuAG->setDisabled(true);
	//-------------------------------------------------------
	QString aboutText ("ksps  Author: Burkhard Bauer");
   
	 QPopupMenu *help = helpMenu(QString(i18n("ksps"))
           + " " + VERSION
           +  i18n("\n\nDieses Programm simuliert eine SPS (* Speicher programmierbare Steuerung*)")
           + i18n("\n\nAutor: Burkhard Brauer 2006")
           + i18n("\nIndustriemeister Fachrichtung Elektrotechnik -Energietechnik-")
           + "\n\neMail:BurkhardBrauer@t-online.de");
	
	
	menu =new KMenuBar(this);
	menu->insertItem(i18n("Projekt"),MenuProjekt);
	menu->insertItem(i18n("Text Baustein"),MenuText);
	menu->insertItem(i18n("Bearbeiten"),MenuBearbeiten);
 	menu->insertItem(i18n("Uebertrage Bausteine ins AG"),MenuAG);
	menu->insertItem(i18n("Help"),help);
	menu->show();
	QObject::connect(menu,SIGNAL(activated(int)),this,SLOT(MenueItem(int)));
  	
	/* pEditorWidget Editor Fenster ****************************************************/
	pEditorWidget=new QWidget(0,"Editor",0);
   QLabel 	*BefehlsTabelle_lbl =new QLabel(i18n("Befehlstabelle "),pEditorWidget,0,0);
	BefehlsTabelle_lbl->setFont(QFont("courier", 16,QFont::Bold));
	BefehlsTabelle_lbl->setGeometry(630,10,200,20);
	QListBox *Befehls_ListBox=new QListBox(pEditorWidget,"Description");
  	Befehls_ListBox->setFont(QFont("courier", 12, QFont::Bold));
	Befehls_ListBox->setGeometry(460,510,730,95);
	Befehls_ListBox->insertItem(i18n("VEK ABH.  =  VEK Abhaengig"));
	Befehls_ListBox->insertItem(i18n("VEK BEEI. =  VEK Beeinflussend"));
	Befehls_ListBox->insertItem(i18n("VEK BERG. =  VEK Begrenzend"));
	Befehls_ListBox->insertItem(i18n("X=1       =  Wenn VEK 1 Signal"));
	Befehls_ListBox->insertItem(i18n("X0>1      =  High Flanke"));
	Befehls_ListBox->insertItem(i18n("X1>0      =  Low Flanke"));
      
	pTabelle=new QTable(64,7,pEditorWidget);
	pTabelle->setGeometry(460,30,730,480);
	pTabelle->setFont(QFont("courier", 10,QFont::Bold));
	pTabelle->setColumnWidth(0,90);
	pTabelle->setColumnWidth(1,90);
	pTabelle->setColumnWidth(2,75);
	pTabelle->setColumnWidth(3,75);
  	pTabelle->setColumnWidth(4,75);
	pTabelle->setColumnWidth(5,600);
	pTabelle->setColumnWidth(6,100);
	for(x=0;x<99;x++)
		pTabelle->setRowHeight(x,20);
	for(x=0;x<7;x++)
	{ 	pTabelle->setColumnStretchable(x,false);
		pTabelle->setRowStretchable(x,true);
	}
	hHeader = pTabelle->horizontalHeader();
	hHeader->setFont(QFont("courier", 10,QFont::Bold));
	hHeader->setLabel(0,i18n("Befehle"),-1);
	hHeader->setLabel(1,i18n("Operanden"),-1);
	hHeader->setLabel(2,i18n("VEK ABH."),-1);
	hHeader->setLabel(3,i18n("VEK BEEIN."),-1);
	hHeader->setLabel(4,i18n("VEK BEGR."),-1);
	hHeader->setLabel(5,i18n("Erklaerungen"),-1);
	hHeader->setLabel(6,i18n("Beispiele"),-1);
   this->BefehlsTabelle();
	
	// Editor
	EditorBausteinUeberschrift_lbl=new QLabel(" BA: ?",pEditorWidget,0);
	EditorBausteinUeberschrift_lbl->setFrameStyle(QFrame::Box | QFrame::Raised);
	EditorBausteinUeberschrift_lbl->setLineWidth(2);
	EditorBausteinUeberschrift_lbl->setFont(QFont("courier", 14,QFont::Bold));
	EditorBausteinUeberschrift_lbl->setGeometry(2,2,85,25);
	BausteinTitelEditor=new QLineEdit(pEditorWidget,"QMultiLineEdit");
	BausteinTitelEditor->setGeometry(92,2,365,25);
	BausteinTitelEditor->setDisabled(true);
	EditorNetzwerkUeberschrift_lbl=new QLabel(" NE: ?",pEditorWidget,0);
	
	EditorNetzwerkUeberschrift_lbl->setFrameStyle(QFrame::Box | QFrame::Raised);
	EditorNetzwerkUeberschrift_lbl->setLineWidth(2);
	
	EditorNetzwerkUeberschrift_lbl->setFont(QFont("courier", 14,QFont::Bold));
	EditorNetzwerkUeberschrift_lbl->setGeometry(2,28,85,25);
	NetzwerkTitelEditor=new QLineEdit(pEditorWidget,"QMultiLineEdit");
	NetzwerkTitelEditor->setGeometry(92,28,310,25);
	NetzwerkTitelEditor->setDisabled(true);
	spinBox_text_NeNr = new QSpinBox(0,0,1,pEditorWidget);
	spinBox_text_NeNr->setFont(QFont("courier", 14, QFont::Bold));
	spinBox_text_NeNr->setGeometry(404,28,55,25);
	QObject::connect(spinBox_text_NeNr,SIGNAL(valueChanged(int)),this, SLOT(get_spinBox_text_NeNr_slot(int)));
			
	Editor=new QMultiLineEdit(pEditorWidget,"QMultiLineEdit");
	Editor->setFont(QFont("courier", 12,QFont::Bold));
	Editor->setGeometry(2,55,455,400);
	Editor->setPaper(QColor(240,240,240));
	Editor->setText(i18n("*Zuerst muessen Sie ein Projekt oeffnen.\n\n"
				"*Da nach koennen Sie einen Baustein erzeugen.\n\n"
				"*Oder Laden ein Projekt ins AG*"));
	Editor->setDisabled(true);
	Editor->setMaxLogLines(3);
	
	QObject::connect(Editor,SIGNAL(textChanged()),this,SLOT(textChanged_slot()));
  	QObject::connect(Editor,SIGNAL(returnPressed()),this,SLOT(returnPressed_slot()));
   FehlerListBox=new QListBox(pEditorWidget,"Error listBox");
   FehlerListBox->setFont(QFont("courier", 12, QFont::Bold));
	FehlerListBox->setGeometry(2,495,455,60);//85);
	QObject::connect(FehlerListBox,SIGNAL(highlighted(int)),this,SLOT(FehlerListBox_slot(int)));
	QObject::connect(FehlerListBox,SIGNAL(selected(int)),this,SLOT(FehlerListBox_slot(int)));
	QPushButton *loescheFehlerListBox=new QPushButton(i18n("Loesche Fehler Liste"),pEditorWidget);
 //  loescheFehlerListBox->setGeometry(150,585,140,20);
   loescheFehlerListBox->setGeometry(150,565,140,20);
	QObject::connect(loescheFehlerListBox,SIGNAL(clicked()),this,SLOT(loescheFehlerListBoxl_clicked()));
	
	loescheNetzwerkBtn=new QPushButton(i18n("Netzwerk loeschen"),pEditorWidget);
   loescheNetzwerkBtn->setGeometry(10,458,140,20);
   QObject::connect(loescheNetzwerkBtn,SIGNAL(clicked()),this,SLOT(loescheNetzwerk_clicked()));
   einfuegenNetzwerkBtn=new QPushButton(i18n("Netzwerk einfuegen"),pEditorWidget);
   einfuegenNetzwerkBtn->setGeometry(160,458,140,20);
   QObject::connect(einfuegenNetzwerkBtn,SIGNAL(clicked()),this,SLOT(einfuegenNetzwerk_clicked()));
 	neuesNetzwerkBtn=new QPushButton(i18n("Neues Netzwerk"),pEditorWidget);
 	neuesNetzwerkBtn->setGeometry(310,458,140,20);
  	QObject::connect(neuesNetzwerkBtn,SIGNAL(clicked()),this,SLOT(neuesNetzwerkBtn_clicked()));
		
	/* TabWidget  StatusWidget *************************************************************************/
	pStatusWidget=new QWidget(0,"StatusWidget",0);
	statusBausteinUeberschrift_Lbl=new QLabel(i18n("Bitte laden Sie einen Baustein ins AG!"),pStatusWidget,0,0);
	statusBausteinUeberschrift_Lbl->setGeometry(2,5,645,25);	
	statusBausteinUeberschrift_Lbl->setFrameStyle(QFrame::Box | QFrame::Raised);
	statusBausteinUeberschrift_Lbl->setLineWidth(2);
	statusBausteinUeberschrift_Lbl->setFont(QFont("courier",14,QFont::Bold));
	statusBausteinUeberschrift_Lbl->setBackgroundColor(Qt::white);
	
	statusNetzwerkUeberschrift_Lbl=new QLabel(i18n(" "),pStatusWidget,0,0);
	statusNetzwerkUeberschrift_Lbl->setFrameStyle(QFrame::Box | QFrame::Raised);
	statusNetzwerkUeberschrift_Lbl->setLineWidth(2);
	statusNetzwerkUeberschrift_Lbl->setGeometry(2,30,645,25);	
	statusNetzwerkUeberschrift_Lbl->setFont(QFont("courier",14,QFont::Bold));
	statusNetzwerkUeberschrift_Lbl->setBackgroundColor(Qt::white);
	
	pRahmen=new QFrame(pStatusWidget,0,0);
	pRahmen->setFrameStyle(QFrame::Panel | QFrame::Sunken);
	pRahmen->setBackgroundColor(Qt::black);
	pRahmen->setLineWidth(2);
	pRahmen->setGeometry(2,62,645,28);
	
	Marke_lbl=new QLabel(i18n("Marke"),pRahmen,"Marke_lbl",0);
	Marke_lbl->setFont(QFont("courier",10,QFont::Bold));
	Marke_lbl->setFrameStyle(QFrame::Box | QFrame::Raised);
	Marke_lbl->setGeometry(4,3,50,20);
	Marke_lbl->setBackgroundColor(QColor(80,80,80));
	Marke_lbl->setPaletteForegroundColor(Qt::green);
	
	
	Befehl_lbl=new QLabel(i18n("Be"),pRahmen,"Befehl_lbl",0);
	Befehl_lbl->setFont(QFont("courier",10,QFont::Bold));
	Befehl_lbl->setFrameStyle(QFrame::Box | QFrame::Raised);
	Befehl_lbl->setGeometry(60,3,30,20);
	Befehl_lbl->setBackgroundColor(QColor(80,80,80));
	Befehl_lbl->setPaletteForegroundColor(Qt::green);
	
	Operand_lbl=new QLabel(i18n("Op"),pRahmen,"Operand_lbl",0);
	Operand_lbl->setFont(QFont("courier",10,QFont::Bold));
  Operand_lbl->setFrameStyle(QFrame::Box | QFrame::Raised);
	Operand_lbl->setGeometry(105,3,30,20);
	Operand_lbl->setBackgroundColor(QColor(80,80,80));
	Operand_lbl->setPaletteForegroundColor(Qt::green);
	
	BitNummerWert_lbl=new QLabel(i18n("BitNo/Val."),pRahmen,"BitNrWert_lbl",0);
	BitNummerWert_lbl->setFont(QFont("courier",10,QFont::Bold));
	BitNummerWert_lbl->setFrameStyle(QFrame::Box | QFrame::Raised);
	BitNummerWert_lbl->setGeometry(150,3,160,20);
	BitNummerWert_lbl->setBackgroundColor(QColor(80,80,80));
	BitNummerWert_lbl->setPaletteForegroundColor(Qt::green);
	
	Inhalt_lbl=new QLabel(i18n("Inhalt"),pRahmen,"Inhalt_lbl",0);
	Inhalt_lbl->setFont(QFont("courier",10,QFont::Bold));
	Inhalt_lbl->setFrameStyle(QFrame::Box | QFrame::Raised);
	Inhalt_lbl->setGeometry(315,3,55,20);
	Inhalt_lbl->setBackgroundColor(QColor(80,80,80));
	Inhalt_lbl->setPaletteForegroundColor(Qt::green);
	
	Vek_lbl=new QLabel(i18n("VEK"),pRahmen,"Vek_lbl",0);
	Vek_lbl->setFont(QFont("courier",10,QFont::Bold));
	Vek_lbl->setFrameStyle(QFrame::Box | QFrame::Raised);
	Vek_lbl->setGeometry(375,3,40,20);
	Vek_lbl->setBackgroundColor(QColor(80,80,80));
	Vek_lbl->setPaletteForegroundColor(Qt::green);
	
	Akku1_2Komentar_lbl=new QLabel(i18n(" Akku1      Akku2"),pRahmen,"Akku1_2Komentar_lbl",0);
	Akku1_2Komentar_lbl->setFont(QFont("courier",10,QFont::Bold));
	Akku1_2Komentar_lbl->setFrameStyle(QFrame::Box | QFrame::Raised);
	Akku1_2Komentar_lbl->setGeometry(420,3,220,20);
	Akku1_2Komentar_lbl->setBackgroundColor(QColor(80,80,80));
	Akku1_2Komentar_lbl->setPaletteForegroundColor(Qt::green);
	
	pStatusAusgabeFenster=new QWidget(pStatusWidget,"StatusAusgabeFenster",0);
  	pStatusAusgabeFenster->setGeometry(2,90,645,450);
	pStatusAusgabeFenster->setBackgroundColor(Qt::black);
	
	ScrollBarVer =new QScrollBar(0,100,1,10,0,QScrollBar::Vertical,pStatusWidget,0);
   ScrollBarVer->setGeometry(648,90,15,450);
 	QObject::connect(ScrollBarVer,SIGNAL(valueChanged(int)),this,SLOT(ScrollVer(int)));
	ComboBox=new QComboBox(pStatusWidget);
  	ComboBox->setGeometry(10,560,80,40);
   QObject::connect(ComboBox,SIGNAL(activated(int)),this,SLOT(statusComboBox_slot(int)));
	spinBoxStatus_NE_Nr = new QSpinBox(0,0,1,pStatusWidget);
	status_spinBox_AlteNetzwerkNr=0;
	spinBoxStatus_NE_Nr->setGeometry(100,560,80,40);
	QObject::connect(spinBoxStatus_NE_Nr,SIGNAL(valueChanged(int)),this, SLOT(status_spinBox_NeNr_slot(int)));
	QButtonGroup *pSliderBox=new QButtonGroup(i18n("Ruft das Programm alle x ms auf."),pStatusWidget);
	pSliderBox->setGeometry(190,550,460,50);
	slider = new QSlider(50,1000,10,50, QSlider::Horizontal,pStatusWidget,"slider"); 
	slider->setGeometry(200,570,300,20);
   QObject::connect( slider, SIGNAL(valueChanged(int)),this,SLOT(getTimeSlider(int)));
 	lcd  = new QLCDNumber(4,pStatusWidget, "lcd" );
	lcd->setGeometry(510,565,50,30);
 	lcd->setPaletteForegroundColor(Qt::green);
	lcd->setPaletteBackgroundColor(Qt::black);
	lcd->setSmallDecimalPoint(false);
   lcd->setSegmentStyle(QLCDNumber::Flat );
   lcd->display(50); 
   QObject::connect( slider, SIGNAL(valueChanged(int)),lcd,SLOT(display(int)));
	//-------------------------------------------------------------------------------------------
	ButtonGroupEB0=new QButtonGroup ("EByte0: Taster",pStatusWidget);
 	ButtonGroupEB0->setGeometry(665,5,168,230);
	Spalte=2;
	Zeile=25;
	Offset=25;
	for(n=0;n<=7;n++)
	{  Frame_EBit[n]=new QFrame(ButtonGroupEB0,"Frame",0);
		Frame_EBit[n]->setGeometry(Spalte,Zeile,60,24);
		Frame_EBit[n]->setFrameStyle(QFrame::Box | QFrame::Raised);
		Frame_EBit[n]->setLineWidth(1);
		sprintf(CStr,"E%d.%d ",n/8,n%8);
		PushButton_EBit[n]=new QPushButton(CStr,ButtonGroupEB0,0);
		PushButton_EBit[n]->setToggleButton(false); 
		PushButton_EBit[n]->setGeometry(Spalte+20,Zeile+4,37,18);		
		if(n<4) 
		 	LED_EBit[n]=new KLed(Qt::green,KLed::Off,KLed::Raised,KLed:: Circular,ButtonGroupEB0,0);
		else
		  LED_EBit[n]=new KLed(Qt::green,KLed::On,KLed::Raised,KLed:: Circular,ButtonGroupEB0,0);
		LED_EBit[n]->setGeometry(Spalte+4,Zeile+5,15,15);
		LEdit_EBit[n] = new QLineEdit(ButtonGroupEB0);
		LEdit_EBit[n]->setFont(QFont("courier",8,QFont::Bold));
		LEdit_EBit[n]->setMaxLength(15);
		LEdit_EBit[n]->setGeometry(Spalte+61,Zeile,100,25);
		Zeile+=Offset;
	}
	QObject::connect(ButtonGroupEB0,SIGNAL(pressed(int)),this,SLOT(ButtonGroupEB0_pressed(int)));
	QObject::connect(ButtonGroupEB0,SIGNAL(released(int)),this,SLOT(ButtonGroupEB0_released(int)));
//-----------------------------------------------------------------------------------------------------------
	ButtonGroupEB1=new QButtonGroup ("EByte1: Schalter",pStatusWidget);
 	ButtonGroupEB1->setGeometry(665,245,168,230);
	Spalte=2;
	Zeile=25;
	Offset=25;
	for(n=8;n<=15;n++)
	{	Frame_EBit[n]=new QFrame(ButtonGroupEB1,"FrameE",0);
		Frame_EBit[n]->setGeometry(Spalte,Zeile,60,24);
		Frame_EBit[n]->setFrameStyle(QFrame::Box | QFrame::Raised);
		Frame_EBit[n]->setLineWidth(1);
		sprintf(CStr,"E%d.%d",n/8,n%8);
		PushButton_EBit[n]=new QPushButton(CStr,ButtonGroupEB1,0);
		PushButton_EBit[n]->setToggleButton(true);
		PushButton_EBit[n]->setGeometry(Spalte+20,Zeile+4,37,18);
		LED_EBit[n]=new KLed(Qt::green,KLed::Off,KLed::Raised,KLed:: Circular,ButtonGroupEB1,0);
		LED_EBit[n]->setGeometry(Spalte+4,Zeile+5,15,15);
		LEdit_EBit[n] = new QLineEdit(ButtonGroupEB1);
		LEdit_EBit[n]->setFont(QFont("courier",8,QFont::Bold));
		LEdit_EBit[n]->setMaxLength(15);
		LEdit_EBit[n]->setGeometry(Spalte+61,Zeile,100,25);
		Zeile+=Offset;
	}
	QObject::connect(ButtonGroupEB1,SIGNAL(clicked(int)),this,SLOT(ButtonGroupEB1_Toggle(int)));
	/* Eingansbytes vom Interface ****************************************************************/
	ButtonGroupEB2=new QButtonGroup ("EByte2: Interface",pStatusWidget);
 	ButtonGroupEB2->setGeometry(840,5,168,230);
	Spalte=2;
	Zeile=25;
	Offset=25;
	for(n=16;n<=23;n++)
	{  Frame_EBit[n]=new QFrame(ButtonGroupEB2,"Frame",0);
		Frame_EBit[n]->setGeometry(Spalte,Zeile,60,24);
		Frame_EBit[n]->setFrameStyle(QFrame::Box | QFrame::Raised);
		Frame_EBit[n]->setLineWidth(1);
		sprintf(CStr,"E%d.%d ",n/8,n%8);
		Label_EBit[n]=new QLabel(CStr,Frame_EBit[n],0);
		Label_EBit[n]->setGeometry(18,2,30,20);
	   LED_EBit[n]=new KLed(Qt::green,KLed::Off,KLed::Raised,KLed:: Circular,ButtonGroupEB2,0);
		LED_EBit[n]->setGeometry(Spalte+4,Zeile+5,15,15);
		LEdit_EBit[n] = new QLineEdit(ButtonGroupEB2);
		LEdit_EBit[n]->setFont(QFont("courier",8,QFont::Bold));
		LEdit_EBit[n]->setMaxLength(15);
		LEdit_EBit[n]->setGeometry(Spalte+61,Zeile,100,25);
		Zeile+=Offset;
	}
	ButtonGroupEB3=new QButtonGroup ("EByte3: Interface",pStatusWidget);
 	ButtonGroupEB3->setGeometry(840,245,168,230);
	Spalte=2;
	Zeile=75;//25;
	Offset=25;
	for(n=26;n<=31;n++)
	{  Frame_EBit[n]=new QFrame(ButtonGroupEB3,"Frame",0);
		Frame_EBit[n]->setGeometry(Spalte,Zeile,60,24);
		Frame_EBit[n]->setFrameStyle(QFrame::Box | QFrame::Raised);
		Frame_EBit[n]->setLineWidth(1);
		sprintf(CStr,"E%d.%d ",n/8,n%8);
		Label_EBit[n]=new QLabel(CStr,Frame_EBit[n],0);
		Label_EBit[n]->setGeometry(18,2,30,20);
	   LED_EBit[n]=new KLed(Qt::green,KLed::Off,KLed::Raised,KLed:: Circular,ButtonGroupEB3,0);
		LED_EBit[n]->setGeometry(Spalte+4,Zeile+5,15,15);
		LEdit_EBit[n] = new QLineEdit(ButtonGroupEB3);
		LEdit_EBit[n]->setFont(QFont("courier",8,QFont::Bold));
		LEdit_EBit[n]->setMaxLength(15);
		LEdit_EBit[n]->setGeometry(Spalte+61,Zeile,100,25);
		Zeile+=Offset;
	}
  /* Ausgaege Ausgangsbytes *********************************************************************/
	ButtonGroupAB0=new QButtonGroup ("AByte0: Ausgaenge",pStatusWidget);
 	ButtonGroupAB0->setGeometry(/*836*/1015,5,159,230);
	Spalte=2;
	Zeile=25;
	Offset=25;
	for(n=0;n<=7;n++)
	{ 	Frame_ABit[n]=new QFrame(ButtonGroupAB0,"FrameA",0);;
		Frame_ABit[n]->setGeometry(Spalte,Zeile,52,24);
		Frame_ABit[n]->setFrameStyle(QFrame::Box | QFrame::Raised);
		Frame_ABit[n]->setLineWidth(1);
		LED_ABit[n]=new KLed(Qt::red,KLed::Off,KLed::Raised,KLed:: Circular,Frame_ABit[n],0);
		LED_ABit[n]->setGeometry(3,4,15,15);
		sprintf(CStr,"A%d.%d",n/8,n%8);
		Label_ABit[n]=new QLabel(CStr,Frame_ABit[n],0);
		Label_ABit[n]->setGeometry(18,2,30,20);
		LEdit_ABit[n] = new QLineEdit(ButtonGroupAB0);
		LEdit_ABit[n]->setFont(QFont("courier",8,QFont::Bold));
		LEdit_ABit[n]->setMaxLength(15);
		LEdit_ABit[n]->setGeometry(Spalte+53,Zeile,100,25);
		Zeile+=Offset;
	}
	ButtonGroupAB1=new QButtonGroup ("AByte1: Ausgaenge",pStatusWidget);
 	ButtonGroupAB1->setGeometry(/*836*/1015,245,159,230);
	Spalte=2;
	Zeile=25;
	Offset=25;
	for(n=8;n<=15;n++)
	{  Frame_ABit[n]=new QFrame(ButtonGroupAB1,"FrameA",0);;
		Frame_ABit[n]->setGeometry(Spalte,Zeile,52,24);
		Frame_ABit[n]->setFrameStyle(QFrame::Box | QFrame::Raised);
		Frame_ABit[n]->setLineWidth(1);
		LED_ABit[n]=new KLed(Qt::red,KLed::Off,KLed::Raised,KLed:: Circular,Frame_ABit[n],0);
		LED_ABit[n]->setGeometry(3,4,15,15);
		sprintf(CStr,"A%d.%d",n/8,n%8);
		Label_ABit[n]=new QLabel(CStr,Frame_ABit[n],0);
		Label_ABit[n]->setGeometry(18,2,30,20);
		LEdit_ABit[n] = new QLineEdit(ButtonGroupAB1);
		LEdit_ABit[n]->setFont(QFont("courier",8,QFont::Bold));
		LEdit_ABit[n]->setMaxLength(15);
		LEdit_ABit[n]->setGeometry(Spalte+53,Zeile,100,25);
		Zeile+=Offset;
	}
	/* ButtonGroupRunStop_Rb *********************************************************************/
	pButtonGroupRunStop_Rb=new QButtonGroup ("Simulator",pStatusWidget);
	pButtonGroupRunStop_Rb->setGeometry(665,480,168,120);
	pAgRun_Rb=new QRadioButton ("Start  [RETURN]",pButtonGroupRunStop_Rb,0 );
	pAgRun_Rb->setGeometry(5,20,130,25);
	pButtonGroupRunStop_Rb->insert(pAgRun_Rb,1);
	pAgStop_Rb=new QRadioButton ("Halt [ESC]",pButtonGroupRunStop_Rb,0 );
	pAgStop_Rb->move(5,45);
	pButtonGroupRunStop_Rb->insert(pAgStop_Rb,2);
	pAgStop_Rb->setChecked(true);
        QObject::connect(pButtonGroupRunStop_Rb,SIGNAL(clicked(int)),this,SLOT(StartStopButton_Rb(int)));
		/* ButtonGroupHexDez_Rb *********************************************************************/
	pButtonGroupHexDez_Rb=new QButtonGroup ("Dez/Hex/Kommentar",pStatusWidget);
	pButtonGroupHexDez_Rb->setGeometry(836,480,159,120);
	pDez_Rb=new QRadioButton ("Akkus: Dez",pButtonGroupHexDez_Rb,0 );
	pDez_Rb->move(5,20);
	pButtonGroupHexDez_Rb->insert(pDez_Rb,DEZ);
	pHex_Rb=new QRadioButton ("Akkus: Hex",pButtonGroupHexDez_Rb,0 );
	pHex_Rb->move(5,45);
	pButtonGroupHexDez_Rb->insert(pHex_Rb,HEX);
	pKommentar_Rb=new QRadioButton ("Kommentar",pButtonGroupHexDez_Rb,0 );
	pKommentar_Rb->move(5,70);
	pButtonGroupHexDez_Rb->insert(pKommentar_Rb,KOMMENTAR);
	pDez_Rb->setChecked(true);
	QObject::connect(pButtonGroupHexDez_Rb,SIGNAL(clicked(int)),this,SLOT(ButtonHexDez_Rb(int)));
	PauseButton=new QPushButton("Pause",pStatusWidget,0);
	PauseButton->setToggleButton(false);
	PauseButton->setGeometry(570,565,70,30);
	QObject::connect(PauseButton,SIGNAL(pressed()),this,SLOT(PauseButton_pressed()));
	QObject::connect(PauseButton,SIGNAL(released()),this,SLOT(PauseButton_released()));
	// RS232 COM (ttySn) on/OFF ***************************************************************************
	pButtonGroupRS232_Rb=new QButtonGroup ("RS232 Schnitstelle",pStatusWidget);
	pButtonGroupRS232_Rb->setGeometry(998,480,174,120);
	ComboBox_ttySn=new QComboBox(pButtonGroupRS232_Rb);
  	ComboBox_ttySn->setGeometry(10,45,160,40);
	ComboBox_ttySn->insertItem("Keine",-1);
  	ComboBox_ttySn->insertItem("ttyS0    9600 Baud",-1);
 	ComboBox_ttySn->insertItem("ttyS0   19200 Baud",-1);
	ComboBox_ttySn->insertItem("ttyS0   38400 Baud",-1);
	ComboBox_ttySn->insertItem("ttyS1    9600 Baud",-1);
 	ComboBox_ttySn->insertItem("ttyS1   19200 Baud",-1);
	ComboBox_ttySn->insertItem("ttyS1   38400 Baud",-1);
	ComboBox_ttySn->insertItem("ttyS2    9600 Baud ",-1);
 	ComboBox_ttySn->insertItem("ttyS2   19200 Baud ",-1);
	ComboBox_ttySn->insertItem("ttyS2   38400 Baud ",-1);
	ComboBox_ttySn->insertItem("ttyS3    9600 Baud",-1);
	ComboBox_ttySn->insertItem("ttyS3   19200 Baud",-1);
	ComboBox_ttySn->insertItem("ttyS3   38400 Baud",-1);

   QObject::connect(ComboBox_ttySn,SIGNAL(activated(int)),this,SLOT(statusComboBox_ttySn_slot(int)));	

/* Zuordnungsliste *******************************************************************************/	
	pZuordnungslisteWidget=new QWidget(0,"ZuordnungslisteWidget",0);
	pEAM_KommentarTabelle=new QTable(256,3,pZuordnungslisteWidget);
	pEAM_KommentarTabelle->setGeometry(15,2,565,590);
	pEAM_KommentarTabelle->setColumnWidth(0,160);
	pEAM_KommentarTabelle->setColumnWidth(1,160);
	pEAM_KommentarTabelle->setColumnWidth(2,160);
	hHeaderEAM_KommentarTabelle =pEAM_KommentarTabelle->horizontalHeader();
	hHeaderEAM_KommentarTabelle->setFont(QFont("courier", 12,QFont::Bold));
	hHeaderEAM_KommentarTabelle->setLabel(0,i18n("Eingaenge"),-1);
	hHeaderEAM_KommentarTabelle->setLabel(1,i18n("Ausgaenge"),-1);
	hHeaderEAM_KommentarTabelle->setLabel(2,i18n("Merker"),-1);
	vHeaderEAM_KommentarTabelle =pEAM_KommentarTabelle->verticalHeader();
	vHeaderEAM_KommentarTabelle->setFont(QFont("courier", 12,QFont::Bold));
	for(n=0;n<=255;n++)
	{  Ergebnis=n/8;
		Rest=n % 8;
		sprintf(CStr,"%d.%d",Ergebnis,Rest);
		vHeaderEAM_KommentarTabelle->setLabel(n,CStr,-1);
	}
	QObject::connect(pEAM_KommentarTabelle,SIGNAL(valueChanged(int,int)),this, SLOT(EAMTabelle_slot(int,int)));
	pTZ_ObPbFbSbKommentarTabelle=new QTable(256,6,pZuordnungslisteWidget);
	pTZ_ObPbFbSbKommentarTabelle->setGeometry(590,2,600,590);
	pTZ_ObPbFbSbKommentarTabelle->setColumnWidth(0,160);
	pTZ_ObPbFbSbKommentarTabelle->setColumnWidth(1,160);
	pTZ_ObPbFbSbKommentarTabelle->setColumnWidth(2,160);
	pTZ_ObPbFbSbKommentarTabelle->setColumnWidth(3,160);
	pTZ_ObPbFbSbKommentarTabelle->setColumnWidth(4,160);
	pTZ_ObPbFbSbKommentarTabelle->setColumnWidth(5,160);	
	hHeaderTZ_ObPbFbSbKommentarTabelle=pTZ_ObPbFbSbKommentarTabelle->horizontalHeader();
	hHeaderTZ_ObPbFbSbKommentarTabelle->setFont(QFont("courier", 12,QFont::Bold));
	hHeaderTZ_ObPbFbSbKommentarTabelle->setLabel(0,i18n("Timer"),-1);
	hHeaderTZ_ObPbFbSbKommentarTabelle->setLabel(1,i18n("Zaehler"),-1);
	hHeaderTZ_ObPbFbSbKommentarTabelle->setLabel(2,i18n("OB's"),-1);
	hHeaderTZ_ObPbFbSbKommentarTabelle->setLabel(3,i18n("PB's"),-1);
	hHeaderTZ_ObPbFbSbKommentarTabelle->setLabel(4,i18n("FB's"),-1);
	hHeaderTZ_ObPbFbSbKommentarTabelle->setLabel(5,i18n("SB's"),-1);
	vHeaderTZ_ObPbFbSbKommentarTabelle =pTZ_ObPbFbSbKommentarTabelle->verticalHeader();
	vHeaderTZ_ObPbFbSbKommentarTabelle->setFont(QFont("courier", 12,QFont::Bold));
	for(n=0;n<=255;n++)
	{ 	sprintf(CStr,"%d",n);
		vHeaderTZ_ObPbFbSbKommentarTabelle->setLabel(n,CStr,-1);
	}
 QObject::connect(pTZ_ObPbFbSbKommentarTabelle,SIGNAL(valueChanged(int,int)),this,SLOT(TZTabelle_slot(int,int)));

	/*  addTab(Widgets) ***************************************************************************/
	TabWidget=new QTabWidget(this,"QTabWidget",0);
 	TabWidget->setGeometry(1,30,BILD_BREITE, BILD_HOEHE-60);
	TabWidget->addTab(pEditorWidget,i18n("Editor"));
  	TabWidget->addTab(pStatusWidget,i18n("Statusanzeige Bausteine"));
	TabWidget->addTab(pZuordnungslisteWidget,i18n("Kommentarliste"));
	QObject::connect(TabWidget ,SIGNAL(currentChanged(QWidget *)),this, SLOT(TabWidget_slot(QWidget *)));

	/* TIMER **************************************************************************************/
	ms10Timer=new QTimer(this);
	QObject::connect(ms10Timer,SIGNAL(timeout()),this, SLOT(TimerAuswerten()));
	ms10Timer->start(10,false);
	AnzeigeTimer=new QTimer(this);
	QObject::connect( AnzeigeTimer,SIGNAL(timeout()),this, SLOT(TAnzeige()));
	SimulationsTimer=new QTimer(this);
	QObject::connect(SimulationsTimer,SIGNAL(timeout()),this, SLOT(SPS_ProgrammAufrufen_Timer()));
	

	
	/* statusbar *********************************************************************************/
	statusbar=new QStatusBar(this,0);
	statusbar->setFont(QFont("courier", 14, QFont::Bold));
	statusbar->setGeometry(0,BILD_HOEHE-20,BILD_BREITE,90);
  	statusbar->message(i18n("Sie muessen zuerst ein Projekt oeffnen!")); 
	ttySx=new ttySn();
	ms.start(QThread::HighestPriority);
 	WorkThread.start(QThread::HighestPriority);

//printf("Bytes:%d\n",sizeof(unsigned long int));
//WorkThread.start(QThread::HighPriority);
}//ENDE ksps()

ksps::~ksps()
{	short n,i;
	for(n=0;n<256;n++)
	{	for(i=0;i<256;i++)
		{	delete []	pOB_NetzwerkUeberschrift[n][i];	
			delete []	pPB_NetzwerkUeberschrift[n][i];	
			delete []	pFB_NetzwerkUeberschrift[n][i];	
			delete []	pSB_NetzwerkUeberschrift[n][i];	
		}
		delete [] pOB_NetzwerkUeberschrift[n];	
		delete [] pPB_NetzwerkUeberschrift[n];	
		delete [] pFB_NetzwerkUeberschrift[n];	
		delete [] pSB_NetzwerkUeberschrift[n];	
		delete [] pOB_BausteinUeberschrift[n];
		delete [] pPB_BausteinUeberschrift[n];
		delete [] pFB_BausteinUeberschrift[n];
		delete [] pSB_BausteinUeberschrift[n];
		delete [] Netzwerk_Text[n];
		delete [] pEingaenge_Kommentar[n];
		delete [] pAusgaenge_Kommentar[n];
		delete [] pMerker_Kommentar[n];
		delete [] pTimer_Kommentar[n];
		delete [] pZaehler_Kommentar[n];
		delete [] pOB_Kommentar[n];
		delete [] pPB_Kommentar[n];
		delete [] pFB_Kommentar[n];
		delete [] pSB_Kommentar[n];
	}//ENDE for(n=0;n<256;n++)
	delete [] pOB_NetzwerkUeberschrift;	
	delete [] pPB_NetzwerkUeberschrift;	
	delete [] pFB_NetzwerkUeberschrift;	
	delete [] pSB_NetzwerkUeberschrift;	
	delete [] pOB_BausteinUeberschrift;
	delete [] pPB_BausteinUeberschrift;
	delete [] pFB_BausteinUeberschrift;
	delete [] pSB_BausteinUeberschrift;
	delete [] Netzwerk_Text;
	delete [] pEingaenge_Kommentar;
	delete [] pAusgaenge_Kommentar;
	delete [] pMerker_Kommentar;
	delete [] pTimer_Kommentar;
	delete [] pZaehler_Kommentar;
	delete [] pOB_Kommentar;
	delete [] pPB_Kommentar;
	delete [] pFB_Kommentar;
	delete [] pSB_Kommentar;
	delete [] CStr_zwischenSpeicher;
	ttySx->~ttySn();
	ms.stop();
	while(!ms.finished());
	WorkThread.stop();
 	while(!WorkThread.finished());
}//ENDE ~ksps()

void ksps::closeEvent( QCloseEvent *ev )
{  int Taste;
	if (!strcmp(Projekt_Kennung,PROJEKT_KENNUNG))
	{ 	Taste=MessageBox->information(this,i18n("Beende das Programm * ksps *!"),
                            i18n("Wollen Sie das Projekt speichern?"),
                            i18n("&Speichere und beende"),
									 i18n("&Beenden ohne speicheren"),
									 i18n("&Abbruch"),0,2);
		switch(Taste)
		{ 	case 0: /*Speichern und beenden*/ 
				if(TextBausteinVorhanden) SpsTextSpeichern();
				ProjektDatenSpeichern();
				ev->accept();
				app->quit(); 
			break;
			case 1: /*Nicht Speichern und beenden*/   
				ev->accept();
				app->quit();; 
			break;
			case 2: /*Programm nicht beenden*/
				ev->ignore();
			break;
   	}//ENDE switch(Taste)
	}
	else
	{	ev->accept();
		app->quit();
	}	
}//ENDE void ksps::closeEvent( QCloseEvent *ev )




int ksps::getIndexComboBox(QString QsuchStr)
{ 	int Anzahl,i;
  	QString CText;
	Anzahl=ComboBox->count();
	for(i=0;i<Anzahl;i++)
	{	CText=ComboBox->text(i);
		if(QsuchStr.compare(CText)==0)
	   	return i;
	}
	return 0;
}// ENDE int getIndexComboBox(QString QsuchStr);


int ksps::vergleichenBausteineNamen(const char* pBausteinName1,const char* pBausteinName2)
{  int v;
 	v=strncmp(pBausteinName1,pBausteinName2,2);
	if(v!=0) return v;
	pBausteinName1+=2;
	pBausteinName2+=2;
	v=atoi(pBausteinName1);
	return v-atoi(pBausteinName2);
}//ENDE int vergleichenBausteineNamen(char *BausteinName1,char *BausteinName2)

void ksps::sortiereComboBox()
{ 	int Anzahl,i,j;
	Anzahl=ComboBox->count();
   char **pText=new char*[Anzahl];
	char *pzwStr;
//Eintraege nach pText[i] copieren	
	for(i=0;i<Anzahl;i++) 
	{	pText[i]=new char[80];
		strcpy(pText[i],ComboBox->text(i));
	}
//Sortieren	
	do  
	{	pzwStr=NULL;
		for(i=1;i<Anzahl;i++)
		{	if(vergleichenBausteineNamen(pText[i-1],pText[i])>0)
			{	pzwStr=pText[i]; 
				pText[i]=pText[i-1];
				pText[i-1]=pzwStr;
			}
		}
	} while(pzwStr);
//doppelte Eintraege entfernen.Das Array muss sortiert sein	
	for(i=j=0;i<Anzahl;) 
	{	if(j!=i) // es wird hierdurch viel copierarbreit gespart 
			strcpy(pText[j],pText[i]); 
		i++;
		while(i<Anzahl && !strcmp(pText[j],pText[i])) i++;
		j++;
	}
//Eintraege wieder in die ComboBox schreiben	
	ComboBox->clear();
	for(i=0;i<j;i++)
	  ComboBox->insertItem(pText[i],i);
	for(i=0;i<Anzahl;i++)
		delete [] pText[i];
	delete [] pText;
}//ENDE sortiereComboBox()

int ksps::FindIndexComboBox(const char *BausteinnamePlusNr)
{  int Anzahl,i;
	Anzahl=ComboBox->count();
   for(i=0;i<Anzahl;i++) 
	{	 if(strcmp(ComboBox->text(i),BausteinnamePlusNr)==0)
			return i;
	}
	return -1;
}//ENDE FindIndexComboBox(char *BausteinnamePlusNr)

void ksps::Alle_Bausteine_ins_AG_laden()
{	FILE 	*stream;
	QString QDateinameAG_Laden,QBausteinname,QBausteinNr,QBausteinnamePlusNummer;
	short pos; 
	bool OK=false;
	QDir d(QProjektpfad);
	QDateipfad=d.path();
   QDateipfad+="/";
	//QDir d= QDir::currentDirPath();// liefert den QDateipfad zurck
	//QDateipfad=d.absPath()+"/";
	statusbar->message(QDateipfad);
   unsigned int datLen;
	d.setNameFilter("*.sps");
   ComboBox->clear();
	for(unsigned int i=0; i<d.count();i++)
	{  QDateinameAG_Laden=d[i];
		pos=QDateinameAG_Laden.findRev('.',-1,false);
		QBausteinnamePlusNummer=QDateinameAG_Laden.left(pos);
		QBausteinname=QDateinameAG_Laden.left(2);
		QBausteinNr=QDateinameAG_Laden.mid(2,pos-2);
 		BausteinNr=QBausteinNr.toInt(0,10);
		if(BausteinNr==0)
		{	statusbar->message(i18n("Konnte nicht laden: >>> " + QDateinameAG_Laden +" <<<"));
			continue;
		}
		QDateipfadPlusDateiname=QDateipfad+QDateinameAG_Laden;
		stream = fopen(QDateipfadPlusDateiname,"rb");
    	fseek(stream, 0, SEEK_END);
		datLen = ftell(stream);
		fseek(stream, 0, SEEK_SET);
    	fread (CStr_zwischenSpeicher, 1, datLen, stream);
		fclose(stream);
		CStr_zwischenSpeicher[datLen] = 0;
		if (0==QBausteinname.compare("ob"))
			BausteinName=OB;
		else if (0==QBausteinname.compare("pb"))
			BausteinName=PB;
		else if (0==QBausteinname.compare("fb"))
			BausteinName=FB;
		else if (0==QBausteinname.compare("sb"))
			BausteinName=SB;
		else
		{  BausteinNr=BausteinName=0;
			statusbar->message(i18n("Konnte nich laden: >>> " + QDateinameAG_Laden +" <<<"));
		}
		if(BausteinName)
		{  OK=TextInZeilenZerlegenUndCompilieren(BausteinName,BausteinNr,CStr_zwischenSpeicher);
			if(!OK)
		   {  FehlerListBox->clear();
				TabWidget->showPage(pEditorWidget);
				SpsTextLaden(QDateipfadPlusDateiname);
				int i=0;
				while(*FehlerMeldung[i] && i<11)
				{	FehlerListBox->insertItem(FehlerMeldung[i]);
					i++;
				}
				return; //Weil Fehler aufgetreten
			}
			
		  ComboBox->insertItem(QBausteinnamePlusNummer,-1);
		 }
	}//ENDE for(unsigned int i=0; i<d.count();i++)
	
	if(BausteinName)
	{	sortiereComboBox();
	   pos=FindIndexComboBox("ob1");
		if(pos>=0)
			statusComboBox_slot(pos);
	   else
			statusComboBox_slot(0);
		spinBoxStatus_NE_Nr->setValue(1);
		TabWidget->showPage(pStatusWidget);	
	}
	//if(ComboBox_AlterIndex) statusComboBox_slot(ComboBox_AlterIndex);
}//ENDE Alle_Bausteine_ins_AG_laden()

void ksps::Baustein_ins_AG_Laden()
{ FILE *stream;
  QString QDateinameAG_Laden,DateiQStr,QStr,QBausteinNr,QBausteinnamePlusNummer;
  int pos=0;
  char *CStr;
  unsigned int  datLen;
  QString QStrZw,QStrBausteinName;//NameBaustein;
  bool OK=false;
  CStr = new char[100000];
  QDateipfadPlusDateiname = fileName->getOpenFileName(QProjektpfad,
	"Programmbausteine (*.sps );;Alle Dateien (*.*)",this );
  
 if( QDateipfadPlusDateiname.length()!=0)
 {	PfadDateiname_zerlegen(QDateipfadPlusDateiname,QDateipfad,QDateinameAG_Laden);

			pos=QDateinameAG_Laden.findRev('.',-1,false);
			QBausteinnamePlusNummer=QDateinameAG_Laden.left(pos);
			QStrBausteinName=QDateinameAG_Laden.left(2);
			QBausteinNr=QDateinameAG_Laden.mid(2,pos-2);
			BausteinNr=QBausteinNr.toInt(0,10);
			stream = fopen(QDateipfadPlusDateiname,"rb");
			if (stream)	
			{	fseek(stream, 0, SEEK_END);
				datLen = ftell(stream);
				fseek(stream, 0, SEEK_SET);
					fread (CStr, 1, datLen, stream);
				fclose(stream);
				CStr[datLen] = 0;
				
				strcpy(CStr_zwischenSpeicher,CStr);
				
				if (0==QStrBausteinName.compare("ob") && BausteinNr>0)
					BausteinName=OB;
				else if (0==QStrBausteinName.compare("pb") && BausteinNr>0)
					BausteinName=PB;
				else if (0==QStrBausteinName.compare("fb") && BausteinNr>0)
					BausteinName=FB;
				else if (0==QStrBausteinName.compare("sb") && BausteinNr>0)
					BausteinName=SB;
				else
				{  BausteinNr=BausteinName=0;
					
				}
			}//END if(stream)
			if(BausteinName) 
			{	OK=TextInZeilenZerlegenUndCompilieren(BausteinName,BausteinNr,CStr_zwischenSpeicher);
				if(!OK)
				{  FehlerListBox->clear();
					TabWidget->showPage(pEditorWidget);
					SpsTextLaden(QDateipfadPlusDateiname);
					int i=0;
					while(*FehlerMeldung[i] && i<11)
					{	FehlerListBox->insertItem(FehlerMeldung[i]);
						i++;
					}
					return; //Weil Fehler aufgetreten
				}
				ComboBox->insertItem(QBausteinnamePlusNummer,-1);
				sortiereComboBox();
				int index=getIndexComboBox(QBausteinnamePlusNummer);
				statusComboBox_slot(index);
				spinBoxStatus_NE_Nr->setValue(1);
				TabWidget->showPage(pStatusWidget);	
			}
			else
				statusbar->message(i18n("Konnte nicht laden: >>> " + QDateinameAG_Laden +" <<<"));
	} 
  else
	statusbar->message(i18n("Konnte nicht laden: >>> " + QDateinameAG_Laden +" <<<"));
 	delete [] CStr;
}//ENDE Baustein_ins_AG_Laden()

void ksps::AG_Loeschen()
{	int Nr;
	//StartStopButton_Rb(2); // 2=Stop
	memset(OB_Infos,0,sizeof(Baustein_Infos)*AnzahlBausteine);
	memset(PB_Infos,0,sizeof(Baustein_Infos)*AnzahlBausteine);
	memset(FB_Infos,0,sizeof(Baustein_Infos)*AnzahlBausteine);
	memset(SB_Infos,0,sizeof(Baustein_Infos)*AnzahlBausteine);
	for(Nr=0;Nr<AnzahlBausteine;Nr++)
	{	if(OB_Zeiger[Nr]!=NULL)
		{	delete [] OB_Zeiger[Nr];
			OB_Zeiger[Nr]=NULL;
		}
		else if(PB_Zeiger[Nr]!=NULL)
		{	delete [] PB_Zeiger[Nr];
			PB_Zeiger[Nr]=NULL;
		}
		else if(FB_Zeiger[Nr]!=NULL)
		{	delete [] FB_Zeiger[Nr];
			FB_Zeiger[Nr]=NULL;
		}
		else if(SB_Zeiger[Nr]!=NULL)
		{	delete [] SB_Zeiger[Nr];
			SB_Zeiger[Nr]=NULL;
		}
	}
	memset(BefehleStack,0,sizeof(BefehleStack)*PROZESS_DATEN);
	memset(AusgabeStatus,0,sizeof(Ausgabe_Str)*AUSGABE_STR_ANZ);
	Code_Anzahl=0;
	StackPointer=0;
	BefehlsPointer=0;
	BausteinName=0;
	BausteinNr=0;
	i_Adresse=0;
	i_returnStack=0;
   returnWert=0;
	Ausgabe_geaendert=true;
	CPU->AG_Neustart();
	ComboBox_AlterIndex=0;
	ComboBox->clear();
	spinBoxStatus_NE_Nr->setValue(0);
	spinBoxStatus_NE_Nr->setMinValue(0);
	spinBoxStatus_NE_Nr->setMaxValue(0);
}//ENDE ksps::AG_Loeschen()


void testAnzeige(StruturCode *BCode,int Anzahl)
{	int AnzahlParameter,n;
	AnzahlParameter=0;
	n=1;
//*******	cout << "Program ByteCode:\n";
	while(n<=Anzahl)  // Anzeige
	{  
		
		AnzahlParameter=BefehlAnzahlParameter[BCode[n].Code];
		if(AnzahlParameter==3)
		{	if(BCode[n].Code>=BEFEHLE_ANFANG && BCode[n].Code<BEFEHLE_ENDE)
			{	printf("| %s ",Befehle[BCode[n].Code]);
				if(BCode[n].Code==BE) break;
			}
			n++;
			if(BCode[n].Code>=TYPEN_ANFANG && BCode[n].Code<TYPEN_ENDE)
			{	printf("| %s ",Typen[BCode[n].Code]);
			}
			n++;
         if(BCode[n-1].Code==K_TIMER)
				printf("| %04X \n",BCode[n].Code);
			else if(BCode[n].Code==ZUR_SP_MARKE)
				printf("| %s \n",Typen[BCode[n].Code]);
			else
				printf("| %d \n",BCode[n].Code);
		}
		else if(AnzahlParameter==2)
		{	if(BCode[n].Code>=AND && BCode[n].Code<BEFEHLE_ENDE)
			{	printf("| %s ",Befehle[BCode[n].Code]);
    			if(BCode[n].Code==BE) break;
			}
			n++;
		if(BCode[n-1].Code==NE)
			printf("| %0d \n",BCode[n].Code);
		else
		 printf("| %s \n",Typen[BCode[n].Code]);
  		}
		else if(AnzahlParameter==1)
		{	if(BCode[n].Code>=AND && (BCode[n].Code<BEFEHLE_ENDE || BCode[n].Code==OR_BLOCK))
			{	printf("| %s \n",Befehle[BCode[n].Code]);
				if(BCode[n].Code==BE) break;
			}
			else if(BCode[n].Code==IST_SP_MARKE)
			{	printf("| %s ",Befehle[BCode[n].Code]);
				if(BCode[n].Code==BE) break;
			}
       }
		n++;
	}//ENDE while(n<=pC)  // Anzeige
}//ENDE testAnzeige(int Anzahl)


bool ksps::TextInZeilenZerlegenUndCompilieren(int BausteinName,int BausteinNr,char *CStr_zwischenSpeicher)
{ 	char *pChar,*pStrZeile;
	short BefehlsCode;
	int Anzahl,Nr,AnzahlNetzwerke,NetzwerkNr=0;
	char CZwStr[80];
	InStringsZerlegenDurchNullen(CStr_zwischenSpeicher,'\n'); //fuer "\n" wird eine "0" eingesetzt
	AlleKomentareLoeschen(CStr_zwischenSpeicher);
	pStrZeile=GenullteStringsAusgeben(CStr_zwischenSpeicher);
	
	pBausteinUeberschrift=NULL;
	switch(BausteinName)
	{	case OB:
			if(pOB_BausteinUeberschrift[BausteinNr]==NULL)
				pOB_BausteinUeberschrift[BausteinNr]=new char[80];
			pBausteinUeberschrift=pOB_BausteinUeberschrift[BausteinNr];
		break;
		case PB:
			if(pPB_BausteinUeberschrift[BausteinNr]==NULL)
				pPB_BausteinUeberschrift[BausteinNr]=new char[80];
			pBausteinUeberschrift=pPB_BausteinUeberschrift[BausteinNr];
		break;
		case FB:
			if(pFB_BausteinUeberschrift[BausteinNr]==NULL)
				pFB_BausteinUeberschrift[BausteinNr]=new char[80];
			pBausteinUeberschrift=pFB_BausteinUeberschrift[BausteinNr];
		break;
		case SB:
			if(pSB_BausteinUeberschrift[BausteinNr]==NULL)
				pSB_BausteinUeberschrift[BausteinNr]=new char[80];
			pBausteinUeberschrift=pSB_BausteinUeberschrift[BausteinNr];
		break;
	}
	
	pChar=strchr(pStrZeile,'~');
	if(pChar) //  pChar=='~'
	{	if(*(pChar+1)!=0)
		{	strcpy(pBausteinUeberschrift,(pChar+1));
		//*****	cout <<  "String: " << (pChar+1) << "\n";
		}
		else
			*pBausteinUeberschrift=0;
		StringLoeschen(pChar);
	}//ENDE if(*pChar=='~') 
	
	AnzahlNetzwerke=0;
	pStrZeile=GenullteStringsAusgeben(NULL);
	while(pStrZeile!=NULL)
	{ 	BefehlsCode=0;
		pChar=strstr(pStrZeile,"NE");
		if(pChar)
		{	strcpy(CZwStr,pStrZeile);
			pChar=strtok(CZwStr,TrennZeichen);
			if(!strcmp(pChar,"NE"))
			{	BefehlsCode=NE;
				pChar=strtok(NULL,TrennZeichen);
				if(pChar)
					NetzwerkNr=atoi(pChar);	
			}
		}
		if(BefehlsCode==NE)
		{	AnzahlNetzwerke++;
			pChar=strchr(pStrZeile,'#');
			if(pChar)
			{ 	switch(BausteinName)
				{	case OB:
						if(pOB_NetzwerkUeberschrift[BausteinNr][NetzwerkNr]==NULL)
							pOB_NetzwerkUeberschrift[BausteinNr][NetzwerkNr]=new char[80];
						strcpy(pOB_NetzwerkUeberschrift[BausteinNr][NetzwerkNr],(pChar+1));
					break;
					case PB:
						if(pPB_NetzwerkUeberschrift[BausteinNr][NetzwerkNr]==NULL)
							pPB_NetzwerkUeberschrift[BausteinNr][NetzwerkNr]=new char[80];
						strcpy(pPB_NetzwerkUeberschrift[BausteinNr][NetzwerkNr],(pChar+1));
					break;
					case FB:
						if(pFB_NetzwerkUeberschrift[BausteinNr][NetzwerkNr]==NULL)
							pFB_NetzwerkUeberschrift[BausteinNr][NetzwerkNr]=new char[80];
						strcpy(pFB_NetzwerkUeberschrift[BausteinNr][NetzwerkNr],(pChar+1));
					break;
					case SB:
						if(pSB_NetzwerkUeberschrift[BausteinNr][NetzwerkNr]==NULL)
							pSB_NetzwerkUeberschrift[BausteinNr][NetzwerkNr]=new char[80];
						strcpy(pSB_NetzwerkUeberschrift[BausteinNr][NetzwerkNr],(pChar+1));
					break;
				}
				//************cout <<  "String: " << (pChar+1) << "\n";
				StringLoeschen(pChar);
			}
		}//ENDE if(BefehlsCode==NE)
		pStrZeile=GenullteStringsAusgeben(NULL);
	}//ENDE 	while((pStrZeile!=NULL)
 

	Anzahl=Compiler(CStr_zwischenSpeicher);
	testAnzeige(BCode,Anzahl);
	
	Nr=BausteinNr;
	if(Anzahl>0)
	{	if (BausteinName==OB)
		{		if (OB_Zeiger[Nr]!=NULL)
					delete [] OB_Zeiger[Nr];
				OB_Zeiger[Nr] = new StruturCode[Anzahl+1];
				memcpy(OB_Zeiger[Nr],BCode,sizeof(StruturCode)*(Anzahl+1));
				OB_Infos[Nr].vorhanden=true;
				OB_Infos[Nr].AnzahlNetzwerke=AnzahlNetzwerke;
		}
		else if  (BausteinName==PB)
		{		if(PB_Zeiger[Nr]!=NULL)
				{	delete [] PB_Zeiger[Nr];
					PB_Zeiger[Nr]=NULL;
				}
				PB_Zeiger[Nr] = new StruturCode[Anzahl+1];
				memcpy(PB_Zeiger[Nr],BCode,sizeof(StruturCode)*(Anzahl+1));
				PB_Infos[Nr].vorhanden=true;
				PB_Infos[Nr].AnzahlNetzwerke=AnzahlNetzwerke;
		}
		else if  (BausteinName==FB)
		{		if(FB_Zeiger[Nr]!=NULL)
					delete [] FB_Zeiger[Nr];
				FB_Zeiger[Nr] = new StruturCode[Anzahl+1];
				memcpy(FB_Zeiger[Nr],BCode,sizeof(StruturCode)*(Anzahl+1));
				FB_Infos[Nr].vorhanden=true;
				FB_Infos[Nr].AnzahlNetzwerke=AnzahlNetzwerke;
		}
		else if  (BausteinName==SB)
		{		if(SB_Zeiger[Nr]!=NULL)
					delete [] SB_Zeiger[Nr];
				SB_Zeiger[Nr] = new StruturCode[Anzahl+1];
				memcpy(SB_Zeiger[Nr],BCode,sizeof(StruturCode)*(Anzahl+1));
				SB_Infos[Nr].vorhanden=true;
				SB_Infos[Nr].AnzahlNetzwerke=AnzahlNetzwerke;
		}
		return true;
	}//ENDE if(Anzahl>0)
	else
		return false;
	  
}//ENDE int TextInZeilenZerlegenUndCompilieren(char *CStr_zwischenSpeicher)



void ksps::resizeEvent(QResizeEvent *Veraenderung)
{    ZeichnungPuffer.resize(Veraenderung->size());
	  //bitBlt(pStatusAusgabeFenster,0,0,&ZeichnungPuffer);
}

void ksps::paintEvent(QPaintEvent *)
{	  bitBlt(pStatusAusgabeFenster,1,1,&ZeichnungPuffer);
} //ENDE paintEvent()


 void ksps::StatusAnzeigePaint()
{ short n,Zeile;
  short AusgabeVon,AusgabeBis;
 	AusgabeVon=offsetZeile;
	AusgabeBis=offsetZeile+21;
      Zeile=0;
      ZeichnungPuffer.fill(black);
		pMaler.begin(&ZeichnungPuffer);
  		pMaler.setPen(Qt::green);
 		pMaler.setFont(statusfont);
		for(n=0;n<BefehlsPointer;n++)
		{	if(AusgabeVon<=n && AusgabeBis>=n)
			{	Zeile+=20;
				if(SPS_RUN  && AusgabeStatus[n].Aktiv)
					pMaler.setPen(Qt::green);
				else
					pMaler.setPen(Qt::darkGreen);
				
				pMaler.drawText(MARKE_SP,Zeile,AusgabeStatus[n].Marke);
				pMaler.drawText(OPERAND_SP,Zeile,AusgabeStatus[n].Befehl);
				pMaler.drawText(TYPE_SP,Zeile,AusgabeStatus[n].Operand);
				pMaler.drawText(PARA_SP,Zeile,AusgabeStatus[n].Wert);
				pMaler.drawText(INHALT_SP,Zeile,AusgabeStatus[n].Inhalt);
				pMaler.drawText(STATUS_SP,Zeile,AusgabeStatus[n].Vek);
				if(AkkuDarstellung==DEZ || AkkuDarstellung==HEX)
				{	pMaler.drawText(AKKU1_SP,Zeile,AusgabeStatus[n].Akku1);
					pMaler.drawText(AKKU2_SP,Zeile,AusgabeStatus[n].Akku2);
				}
				else if(AkkuDarstellung==KOMMENTAR)
					pMaler.drawText(Kommentar_SP,Zeile,AusgabeStatus[n].EAMTZ_Kommentar);
			
			}
		}
		pMaler.end();
  	repaint();// weil es die Ausgabe syncronisiert
	}//ENDE StatusAnzeigePaint()

void ksps::BausteinBefehlsfolge(int BausteinName,int BausteinNr,int BausteinNetzwerkNr)
{	int pC;
	short Befehl,Operand,ZahlenWert;
   bool SprungMarke;
	StruturCode *PCode=NULL;
	bool Einschreiben;
	if(BausteinName==OB)
  		PCode=OB_Zeiger[BausteinNr];
   else if(BausteinName==PB)
		PCode=PB_Zeiger[BausteinNr];
	else if(BausteinName==FB)
		PCode=FB_Zeiger[BausteinNr];
	else if(BausteinName==SB)
		PCode=SB_Zeiger[BausteinNr];
	memset(BefehleStack,0,sizeof(BefehleStack)*PROZESS_DATEN);
	Einschreiben=false;
   BefehlsPointer=0;
	pC=1;
   StatusAnzeigen=false;
	SprungMarke=false;
	if(!PCode)
	{	statusbar->message(i18n("Error: Unit failure Pointer PCode=NULL "),2000);
	   return;
	}
	while(pC<PCode[0].Code)
	{  Befehl=Operand=ZahlenWert=0;
		switch(BefehlAnzahlParameter[PCode[pC].Code])
		{  case 1:
					Befehl=PCode[pC].Code;
					if(Befehl==IST_SP_MARKE)
					{ 	strcpy(BefehleStack[BefehlsPointer].MarkeName,PCode[pC].MarkeName);
						strcat(BefehleStack[BefehlsPointer].MarkeName,":");
						pC++;
						SprungMarke=true;
					}
		         else	pC++;
			break;
			case 2:
					Befehl=PCode[pC++].Code;
					Operand=PCode[pC++].Code;
			break;
			case 3:
					Befehl=PCode[pC++].Code;
					Operand=PCode[pC++].Code;
            	ZahlenWert=PCode[pC++].Code;
			break;
			default:
				
				exit(-1);
		}//ENDE switch(BefehlAnzahlParameter[BCode[pC]->Code])
   //   printf("BausteinBefehlsfolge: %s   %s   %d\n",Befehle[Befehl],Typen[Operand],ZahlenWert);

	   if(Operand==GLEICH_MARKE)
		{	strcpy(BefehleStack[BefehlsPointer].MarkeName,PCode[pC-1].MarkeName);
		}
		else if(!SprungMarke)
			strcpy(BefehleStack[BefehlsPointer].MarkeName,"");
		SprungMarke=false;

		if(Befehl==NE && Operand==BausteinNetzwerkNr)
		{	Einschreiben=true;
			StatusAnzeigen=true;
			continue;
		}
		else if (Befehl==NE && Operand!=BausteinNetzwerkNr && Einschreiben)
		{	break;
		}

		if(Einschreiben and Befehl!=BE)
		{	BefehleStack[BefehlsPointer].Befehl=Befehl;
			BefehleStack[BefehlsPointer].Operand=Operand;
			BefehleStack[BefehlsPointer].Wert=ZahlenWert;
			BefehlsPointer++;
		}
	}//ENDE while(pC<PCode[0].Code)
}//ENDE void BausteinBefehlsfolge(int BausteinName,int BausteinNr,int BausteinNetzwerkNr)

void ksps::BefehleStrings()
{  int StatusZeile;
	short DezZeit=0,ZeitBasis=0;
	unsigned int Byte,Bit;
	int Befehl,Operand,ZahlenWert=0;
	memset(AusgabeStatus,0,sizeof(AusgabeStatus)*AUSGABE_STR_ANZ);
	StatusAnzeigen=true;
	for (StatusZeile=0;StatusZeile<BefehlsPointer;StatusZeile++)
	{  Befehl=BefehleStack[StatusZeile].Befehl;
		Operand=BefehleStack[StatusZeile].Operand;
		ZahlenWert=BefehleStack[StatusZeile].Wert;

		Byte=ZahlenWert / 8;
		Bit=ZahlenWert % 8;

      if(Befehl==IST_SP_MARKE)
			strcpy(AusgabeStatus[StatusZeile].Marke,BefehleStack[StatusZeile].MarkeName);
		else
 			strcpy(AusgabeStatus[StatusZeile].Marke,"");
		if(Befehl!=IST_SP_MARKE)
				strcpy(AusgabeStatus[StatusZeile].Befehl,Befehle[Befehl]);


		switch(Befehl)
		{	case AND_KL_AUF:
		   case OR_KL_AUF:
		   case OR_BLOCK:
			case KL_ZU:
					strcpy(AusgabeStatus[StatusZeile].Operand,"");
					strcpy(AusgabeStatus[StatusZeile].Wert,"");
			break;
			case AND:
			case OR:
			case AND_NOT:
			case OR_NOT:
			case IST:
			case RESET:
			case SET:
				switch(Operand)
				{	case EINGANG:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d.%1d",Byte,Bit);
						sprintf(AusgabeStatus[StatusZeile].EAMTZ_Kommentar,"%s",pEingaenge_Kommentar[ZahlenWert]);
					break;
					case AUSGANG:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d.%1d",Byte,Bit);
						sprintf(AusgabeStatus[StatusZeile].EAMTZ_Kommentar,"%s",pAusgaenge_Kommentar[ZahlenWert]);
					break;
					case MERKER:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d.%1d",Byte,Bit);
						sprintf(AusgabeStatus[StatusZeile].EAMTZ_Kommentar,"%s",pMerker_Kommentar[ZahlenWert]);
					break;
					case TIMER:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						sprintf(AusgabeStatus[StatusZeile].EAMTZ_Kommentar,"%s",pTimer_Kommentar[ZahlenWert]);
					break;
					case ZAEHLER:
                  strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						sprintf(AusgabeStatus[StatusZeile].EAMTZ_Kommentar,"%s",pZaehler_Kommentar[ZahlenWert]);
					break;
				}//ENDE switch(Operand)
			break;
			case ADD:
  						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
			break;
			case SE_TIMER:
			case SI_TIMER:
			case SV_TIMER:
			case SA_TIMER:
			case SS_TIMER:
					strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
					sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
					sprintf(AusgabeStatus[StatusZeile].EAMTZ_Kommentar,"%s",pTimer_Kommentar[ZahlenWert]);
			break;
			case ZV:
			case ZR:
				strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
				sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
				sprintf(AusgabeStatus[StatusZeile].EAMTZ_Kommentar,"%s",pZaehler_Kommentar[ZahlenWert]);
			break;
			case SPA:
			case SPB:
				switch(Operand)
				{ 	case OB:
							strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
							sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
							sprintf(AusgabeStatus[StatusZeile].EAMTZ_Kommentar,"%s",pOB_Kommentar[ZahlenWert]);
					break;
					case PB:
							strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
							sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
							sprintf(AusgabeStatus[StatusZeile].EAMTZ_Kommentar,"%s",pPB_Kommentar[ZahlenWert]);
					break;
					case FB:
							strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
							sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
							sprintf(AusgabeStatus[StatusZeile].EAMTZ_Kommentar,"%s",pFB_Kommentar[ZahlenWert]);
					break;
					case SB:
							strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
							sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
							sprintf(AusgabeStatus[StatusZeile].EAMTZ_Kommentar,"%s",pSB_Kommentar[ZahlenWert]);
					break;
					case  GLEICH_MARKE:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						strcpy(AusgabeStatus[StatusZeile].Wert,BefehleStack[StatusZeile].MarkeName);
					break;
				}
			break;
			case LOAD:
				switch(Operand)
				{	case E_BYTE:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
					break;
					case E_WORD:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
					break;
					case A_BYTE:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
					break;
					case A_WORD:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
					break;
					case M_BYTE:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
					break;
					case M_WORD:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
					break;
					case K_B_ZAHL:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
				break;
				case K_F_ZAHL:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%5d",ZahlenWert);
				break;
				case K_H_ZAHL:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						CPU->DezToHex(ZahlenWert,AusgabeStatus[StatusZeile].Wert);
				break;
				case K_M_ZAHL:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						CPU->DezToBin(ZahlenWert,AusgabeStatus[StatusZeile].Wert);
				break;
				case K_Y_ZAHL:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						CPU->ZahlToKy(ZahlenWert,AusgabeStatus[StatusZeile].Wert);
				break;
				case TIMER:
							strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
							sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
							sprintf(AusgabeStatus[StatusZeile].EAMTZ_Kommentar,"%s",pTimer_Kommentar[ZahlenWert]);
				break;
				case ZAEHLER:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						sprintf(AusgabeStatus[StatusZeile].EAMTZ_Kommentar,"%s",pZaehler_Kommentar[ZahlenWert]);
				break;
				case K_ZAEHLER:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",CPU->KZ_BcdToDez(ZahlenWert));
				break;
				case K_TIMER:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						DezZeit=CPU->KT_BcdToDez(ZahlenWert,ZeitBasis);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%03d.%d",DezZeit,ZeitBasis);
				break;
				}//ENDE switch(Operand)
			break; // case LOAD
			case LC:
					switch(Operand)
					{	case TIMER:
							strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
							sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
							sprintf(AusgabeStatus[StatusZeile].EAMTZ_Kommentar,"%s",pTimer_Kommentar[ZahlenWert]);
						break;
						case ZAEHLER:
							strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
							sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
							sprintf(AusgabeStatus[StatusZeile].EAMTZ_Kommentar,"%s",pZaehler_Kommentar[ZahlenWert]);
						break;
					}
			break;
			case TRANSVER:
				switch(Operand)
				{	case E_BYTE:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
					break;
					case E_WORD:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						 sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
					break;
					case A_BYTE:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
					break;
					case A_WORD:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
					break;
					case M_BYTE:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
					break;
					case M_WORD:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
					break;
				}//ENDE switch(Operand)
			break; //ENDE case TRANSVER:
			case GLEICH:
			case UNGLEICH:
			case GROESSER:
			case GROESSER_GLEICH:
			case KLEINER:
			case KLEINER_GLEICH:
				strcpy(AusgabeStatus[StatusZeile].Operand,"");
				strcpy(AusgabeStatus[StatusZeile].Wert,"");
			break;
		}//ENDE	switch(Befehl)
	}//ENDE for (StatusZeile=0;StatusZeile<BefehlsPointer,StatusZeile)
}//ENDE StatusAnzeige

void ksps::StatusStrings()
{  int StatusZeile, zwZahl;
	short DezZeit=0,ZeitBasis=0;
	unsigned int Byte,Bit;
   short Op_Inhalt;
   short Befehl,Operand,ZahlenWert,Inhalt,Alu,Akku1,Akku2;
   if(!BefehleStack[0].Befehl)
	{	ProzessPointer=0;
	}
	for (StatusZeile=0;StatusZeile<BefehlsPointer;StatusZeile++)
	{  Befehl=BefehleStack[StatusZeile].Befehl;
		Operand=BefehleStack[StatusZeile].Operand;
		ZahlenWert=BefehleStack[StatusZeile].Wert;
		Alu=ProzessStack[StatusZeile].Vek;
		Inhalt=ProzessStack[StatusZeile].Inhalt;
		Akku1=ProzessStack[StatusZeile].Akku1;
		Akku2=ProzessStack[StatusZeile].Akku2;

		Byte=ZahlenWert / 8;
		Bit=ZahlenWert % 8;

      if(Befehl==IST_SP_MARKE)
			strcpy(AusgabeStatus[StatusZeile].Marke,BefehleStack[StatusZeile].MarkeName);
		else
 			AusgabeStatus[StatusZeile].Marke[0]=0;
		
		if(Befehl!=IST_SP_MARKE)
				strcpy(AusgabeStatus[StatusZeile].Befehl,Befehle[Befehl]);

		if(ProzessStack[StatusZeile].Bearbeitet)
         AusgabeStatus[StatusZeile].Aktiv=true;
		else
 			AusgabeStatus[StatusZeile].Aktiv=false;

		switch(Befehl)
		{	case AND_KL_AUF:
		   case OR_KL_AUF:
		   case OR_BLOCK:
			case KL_ZU:
					*AusgabeStatus[StatusZeile].Operand = 0;
					*AusgabeStatus[StatusZeile].Wert = 0;
					*AusgabeStatus[StatusZeile].Inhalt = 0;
			break;
			case AND:
			case OR:
			case AND_NOT:
			case OR_NOT:
			case IST:
			case RESET:
				switch(Operand)
				{	case EINGANG:
					case AUSGANG:
					case MERKER:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d.%1d",Byte,Bit);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%1d",Inhalt);
						else
							*AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
					case TIMER:
					case ZAEHLER:
                  strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						sprintf(AusgabeStatus[StatusZeile].Vek,"%1d",Alu);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%1d",Inhalt);
						else
							*AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
				}//ENDE switch(Operand)
			break;
			case ADD:
  						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						sprintf(AusgabeStatus[StatusZeile].Vek,"%1d",Alu);
						*AusgabeStatus[StatusZeile].Inhalt = 0;
			break;
			case SET:
				switch(Operand)
				{	case EINGANG:
					case AUSGANG:
					case MERKER:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d.%1d",Byte,Bit);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%1d",Inhalt);
  						else
                     *AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
					case TIMER:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						sprintf(AusgabeStatus[StatusZeile].Vek,"%1d",Alu);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%1d",Inhalt);
  						else
							*AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
					case ZAEHLER:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						sprintf(AusgabeStatus[StatusZeile].Vek,"%1d",Alu);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%03d",CPU->Z_Stand[ZahlenWert]);
						else
							*AusgabeStatus[StatusZeile].Inhalt = 0;
				}//ENDE switch(Operand)
			break;
			case SE_TIMER:
			case SI_TIMER:
			case SV_TIMER:
			case SA_TIMER:
			case SS_TIMER:
					strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
					sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
					if(ProzessStack[StatusZeile].Bearbeitet)
					{	sprintf(AusgabeStatus[StatusZeile].Inhalt,"%d.%d",CPU->TLaufZeit[ZahlenWert],
				     CPU->Zeitraster[ZahlenWert]);
					}
					else
						*AusgabeStatus[StatusZeile].Inhalt = 0;
			break;
			case ZV:
			case ZR:
				strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
				sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
				if(ProzessStack[StatusZeile].Bearbeitet)
					sprintf(AusgabeStatus[StatusZeile].Inhalt,"%03d",CPU->Z_Stand[ZahlenWert]);
				else
					*AusgabeStatus[StatusZeile].Inhalt = 0;
			break;
			case SPA:
			case SPB:
				switch(Operand)
				{ 	case OB:
					case PB:
					case FB:
					case SB:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						*AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
					case  GLEICH_MARKE:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						strcpy(AusgabeStatus[StatusZeile].Wert,BefehleStack[StatusZeile].MarkeName);
						*AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
				}
			break;
			case LOAD:
				switch(Operand)
				{	case E_BYTE:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%3d",CPU->Load(E_BYTE,ZahlenWert));
						else
							*AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
					case E_WORD:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%5d",CPU->Load(E_WORD,ZahlenWert));
						else
							*AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
					case A_BYTE:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%3d",CPU->Load(A_BYTE,ZahlenWert));
						else
							*AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
					case A_WORD:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%5d",CPU->Load(A_WORD,ZahlenWert));
						else
							*AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
					case M_BYTE:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%3d",CPU->Load(M_BYTE,ZahlenWert));
						else
							*AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
					case M_WORD:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%3d",CPU->Load(M_WORD,ZahlenWert));
						else
							*AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
					case K_B_ZAHL:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						*AusgabeStatus[StatusZeile].Wert=0;
				break;
				case K_F_ZAHL:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert," +%05d",ZahlenWert);
						*AusgabeStatus[StatusZeile].Inhalt = 0;
				break;
				case K_H_ZAHL:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						CPU->DezToHex(ZahlenWert,AusgabeStatus[StatusZeile].Wert);
						*AusgabeStatus[StatusZeile].Inhalt = 0;
				break;
				case K_M_ZAHL:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						CPU->DezToBin(ZahlenWert,AusgabeStatus[StatusZeile].Wert);
						*AusgabeStatus[StatusZeile].Inhalt = 0;
				break;
				case K_Y_ZAHL:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						CPU->ZahlToKy(ZahlenWert,AusgabeStatus[StatusZeile].Wert);
						*AusgabeStatus[StatusZeile].Inhalt = 0;
				break;
				case TIMER:
							Op_Inhalt=CPU->getBit(Operand,ZahlenWert);
							strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
							sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
							if(ProzessStack[StatusZeile].Bearbeitet)
								sprintf(AusgabeStatus[StatusZeile].Inhalt,"%d",Inhalt);
							else
								*AusgabeStatus[StatusZeile].Inhalt = 0;
				break;
				case ZAEHLER:
						Op_Inhalt=CPU->getBit(Operand,ZahlenWert);
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%d",Inhalt);
						else
							*AusgabeStatus[StatusZeile].Inhalt = 0;
				break;
				case K_ZAEHLER:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",CPU->KZ_BcdToDez(ZahlenWert));
						*AusgabeStatus[StatusZeile].Inhalt = 0;
				break;
				case K_TIMER:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						DezZeit=CPU->KT_BcdToDez(ZahlenWert,ZeitBasis);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%03d.%d",DezZeit,ZeitBasis);
						*AusgabeStatus[StatusZeile].Inhalt = 0;
				break;
			}//ENDE switch(Operand)
			break; // case LOAD
			case LC:
					switch(Operand)
					{	case TIMER:
							Op_Inhalt=CPU->getBit(Operand,ZahlenWert);
							strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
							sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
							if(ProzessStack[StatusZeile].Bearbeitet)
								sprintf(AusgabeStatus[StatusZeile].Inhalt,"%d",Inhalt);
							else
								*AusgabeStatus[StatusZeile].Inhalt = 0;
						break;
						case ZAEHLER:
								Op_Inhalt=CPU->getBit(Operand,ZahlenWert);
								strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
								sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
								if(ProzessStack[StatusZeile].Bearbeitet)
									sprintf(AusgabeStatus[StatusZeile].Inhalt,"%d",Inhalt);
								else
									*AusgabeStatus[StatusZeile].Inhalt = 0;
						break;
					}
			break;
			case TRANSVER:
				switch(Operand)
				{	case E_BYTE:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%3d",CPU->Load(E_BYTE,ZahlenWert));
						else
							*AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
					case E_WORD:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						 sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%3d",CPU->Load(E_WORD,ZahlenWert));
						else
							*AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
					case A_BYTE:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%3d",CPU->Load(A_BYTE,ZahlenWert));
						else
							*AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
					case A_WORD:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%3d",CPU->Load(A_WORD,ZahlenWert));
						else
							*AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
					case M_BYTE:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%3d",CPU->Load(M_BYTE,ZahlenWert));
						else
							*AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
					case M_WORD:
						strcpy(AusgabeStatus[StatusZeile].Operand,Typen[Operand]);
						sprintf(AusgabeStatus[StatusZeile].Wert,"%3d",ZahlenWert);
						if(ProzessStack[StatusZeile].Bearbeitet)
							sprintf(AusgabeStatus[StatusZeile].Inhalt,"%3d",CPU->Load(M_WORD,ZahlenWert));
						else
							*AusgabeStatus[StatusZeile].Inhalt = 0;
					break;
				}//ENDE switch(Operand)
			break; //ENDE case TRANSVER:
			case GLEICH:
			case UNGLEICH:
			case GROESSER:
			case GROESSER_GLEICH:
			case KLEINER:
			case KLEINER_GLEICH:
				*AusgabeStatus[StatusZeile].Operand=0;
				*AusgabeStatus[StatusZeile].Wert=0;
				*AusgabeStatus[StatusZeile].Inhalt = 0;
			break;
		}//ENDE	switch(Befehl)
		if(ProzessStack[StatusZeile].Bearbeitet)
		{	sprintf(AusgabeStatus[StatusZeile].Vek,"%1d",Alu);
			if(AkkuDarstellung==DEZ)
			{	sprintf(AusgabeStatus[StatusZeile].Akku1,"%+06i",Akku1);
				sprintf(AusgabeStatus[StatusZeile].Akku2,"%+06i",Akku2);
			}
			else if(AkkuDarstellung==HEX)
			{	zwZahl=Akku1;
				zwZahl&=0xFFFF;
				sprintf(AusgabeStatus[StatusZeile].Akku1,"%04X",zwZahl);
				zwZahl=Akku2;
				zwZahl&=0xFFFF;
				sprintf(AusgabeStatus[StatusZeile].Akku2,"%04X",zwZahl);
			}
		}
      else
		{ 	*AusgabeStatus[StatusZeile].Vek=0;
			*AusgabeStatus[StatusZeile].Akku1=0;
			*AusgabeStatus[StatusZeile].Akku2=0;
		}
	}//ENDE for (StatusZeile=0;StatusZeile<BefehlsPointer,StatusZeile)
	memset(ProzessStack,0,sizeof(ProzessStack)*PROZESS_DATEN);
}//ENDE StatusAnzeige

void ksps::keyPressEvent(QKeyEvent *e)
{ 	int Taste;
	Taste=e->key();
	//cout << Taste << "\n";
	switch(Taste)
	{	case Key_Return:// Start Simulation
			switch(TabWidget->currentPageIndex()==1) // 1=pEditorWidget sichtbar
			{	case 1:	
					StartStopButton_Rb(1); 	// 1=Stop
				break;			
				case 2:	
				break;	
			}
		break;
		case Key_Escape: // Stop Simulation
			StartStopButton_Rb(2); // 2=start 
		break;
    	case Key_F10:	
		break;
		case Key_F2: 
			if(TabWidget->currentPageIndex()==0) // 0=pStatusWidget sichtbar
				Ganzen_TextFormatieren();
		break;
		default:;
	}//ENDE switch(Taste)
}//ENDE keyPressEvent(QKeyEvent *e)

void ksps::Ganzen_TextFormatieren()
{ unsigned short Max_Zeilen=0,Zeile=0,n=0;
  char CStr[256];  
	 strcpy(CStr_zwischenSpeicher,Editor->text());
 	 LeerzeilenEntfernen(CStr_zwischenSpeicher);
	 Editor->setText(CStr_zwischenSpeicher);
	 Max_Zeilen=Editor->numLines();
    for(Zeile=0;Zeile<=Max_Zeilen;Zeile++)
		{ QStr=Editor->textLine(Zeile);
			if(!QStr.isEmpty())
			{  strcpy(CStr,QStr);
				 Editor->setCursorPosition(Zeile,0);
				 ZeileToUpperBis_Dollar(CStr);
		     TextFormatiren(CStr);
         Editor->doKeyboardAction(QTextEdit::ActionKill); // Zeile l�chen
			 Editor->insertAt(CStr,Zeile,0);
         n=strlen(CStr);
				 Editor->setCursorPosition(Zeile,n);
			}
		}
}//ENDE Ganzen_TextFormatieren()

void ksps::returnPressed_slot()
{   int Zeile,Spalte,n;
	 unsigned int FehlerBits=0;
	 char CStr[256];
	 Editor->getCursorPosition(&Zeile,&Spalte);
	 Zeile--;
	 QStr=Editor->textLine(Zeile);
	 if(QStr.length()>0)
	 { strcpy(CStr,QStr);
		ZeileToUpperBis_Dollar(CStr);
		FehlerBits=PruefenUndFormatieren(CStr);
		if(FehlerBits)
			statusbar->message("  *** Input error ***",2000);
		n=strlen(CStr);CStr[n]=0;
		if(n)
		{ 	if(Editor->atEnd()) Editor->removeLine(Zeile);
			Editor->insertParagraph (CStr,Zeile);
			Editor->removeLine(Zeile+1);
			Editor->insertParagraph ("",Zeile+1);
			Editor->setCursorPosition(Zeile+1,7,true);
			Editor->doKeyboardAction(QTextEdit::ActionKill);//NEU
		}
	 }
	 if(Zeile>=255)  Editor->removeLine(Zeile);
}//ENDE returnPressed_slot()

unsigned int ksps::TextFormatiren(char* CStr) // F2
{	return PruefenUndFormatieren(CStr); 
}//ENDE TextFormatiren(char* CStr)

void ksps::textChanged_slot()
{  int Zeile,Spalte;
	Editor->getCursorPosition(&Zeile,&Spalte);
}//ENDE textChanged_slot()

void ksps::ButtonGroupEB0_pressed(int ButtonNr)
{  if(ButtonNr<4)
  	{ 	LED_EBit[ButtonNr]->on();
   	fast_SetBit(EB_Port[0],ButtonNr);
	}
	else
	{	LED_EBit[ButtonNr]->off(); 
		fast_ResetBit(EB_Port[0],ButtonNr);
	}
}//ENDE ButtonGroupEB0_pressed

void ksps::ButtonGroupEB0_released(int ButtonNr)
{ 	if(ButtonNr<4)
	{	LED_EBit[ButtonNr]->off();
   	fast_ResetBit(EB_Port[0],ButtonNr);
	}
	else
	{	LED_EBit[ButtonNr]->on();
		fast_SetBit(EB_Port[0],ButtonNr);
	}
}//ENDE ButtonGroupEB0_released(int ButtonNr)

void ksps::ButtonGroupEB1_Toggle(int ButtonNr)
{		ButtonNr+=8;
		if(PushButton_EBit[ButtonNr]->isOn())
		{	LED_EBit[ButtonNr]->on();
      	fast_SetBit(EB_Port[1],ButtonNr);
		}
		else
      {	LED_EBit[ButtonNr]->off();
			fast_ResetBit(EB_Port[1],ButtonNr);
		}
}//ENDE ButtonGroupEB1_BoxChecked

void ksps::EBytes_LED_Anzeige()
{	int n;
	char Byte;
	Byte=EB_Port[2];
	for(n=16; n<=23; n++)
	{	if(Byte & 1)
		{	LED_EBit[n]->on();	
		
		}
		else
			LED_EBit[n]->off();	
		Byte=Byte >> 1;
	}
	Byte=EB_Port[3];
	Byte=Byte >> 2;
	for(n=26; n<=31; n++)
	{	if(Byte & 1)
			LED_EBit[n]->on();	
		else
			LED_EBit[n]->off();	
		Byte=Byte >> 1;
	}
}//END EByte2u3_LED()


void ksps::ABytes_LED_Anzeige()
{	unsigned short n,BitNr;
	for(BitNr=0,n=0; n<=7; BitNr++,n++)
	{ 	if(fast_GetBit(AB_Port[0],BitNr))  //(ABit[n])
		{ 	if(AB_staticFarbe[n]!=255) 	
		  	{	LED_ABit[n]->on();
				AB_staticFarbe[n]=255;
			}
		}
		else  
		{	if(AB_staticFarbe[n]!=128)	
			{ 	LED_ABit[n]->off();
				AB_staticFarbe[n]=128;
			}
		}
	}//ENDE for()
	for(BitNr=0,n=8; n<=15;	BitNr++,n++)
	{ 	if(fast_GetBit(AB_Port[1],BitNr))  //(ABit[n])
		{ 	if(AB_staticFarbe[n]!=255) 	
		  	{	LED_ABit[n]->on();
				AB_staticFarbe[n]=255;
			}
		}
		else  
		{	if(AB_staticFarbe[n]!=128)	
			{ 	LED_ABit[n]->off();
				AB_staticFarbe[n]=128;
			}
		}
	}//ENDE for()
}//ENDE ABytes_LED_Anzeige()

double ZeitRasterDouble(short Zeitraster)
{	switch(Zeitraster)
	{	case 0:
			return 10.0;
		case 1:
			return 100.0;
		case 2:
			return 1000.0;
		case 3:
			return 10000.0;
		default:
			return 0.0;
	}
}//Ende ZeitRasterDouble()

short RestZeit(int n)
{	double msZeitraster,msRestZeit;
	miliSekunden_double=ms.GetTickCounter();
   msRestZeit=CPU->msTLaufZeit[n]-(miliSekunden_double-CPU->msTimerStart[n]);			
	msZeitraster=ZeitRasterDouble(CPU->Zeitraster[n]);
   return  short((msRestZeit+msZeitraster)/msZeitraster);
}//ENDE RestZeit()

void ksps::TimerAuswerten()
{ 	showRun++;
	for(int n=0;n<=255;n++)
	{	if(CPU->T_Input[n])
	  	{	if(CPU->TLaufZeit[n]>0)
		 	{	CPU->TLaufZeit[n]=RestZeit(n);
				if(CPU->TLaufZeit[n]<0) CPU->TLaufZeit[n]=0;
		  	}
		}
	}
}//ENDE TimerAuswerten()




void ksps::SPS_ProgrammAufrufen_Timer()
{	//****************************************
  unsigned char ButtonNr;
	static bool RunAzeige=false;
	char EBit;
  BausteinName=OB;
  BausteinNr=1;
  if(NeuenStatusAnzeigen_vonThread)
  {     
	StatusStrings();
		StatusAnzeigePaint();	
		NeuenStatusAnzeigen_vonThread=false;
	}

	if(showRun<100 && RunAzeige==false)
	{	RunAzeige=true;
		statusbar->message(i18n("Simulation: laeuft"),1000);
	}
	else if(showRun>200) 
	{	RunAzeige=false;
		showRun=0;
	}		


return;
 /* unsigned char ButtonNr;
	static bool RunAzeige=false;
	char EBit;
*/
	BausteinName=OB;
  	BausteinNr=1;
  
	for(ButtonNr=0;ButtonNr<=15;ButtonNr++)
   { if(ButtonNr<4)
		EBit=PushButton_EBit[ButtonNr]->isDown();
	 else if(ButtonNr<8)
		EBit=!PushButton_EBit[ButtonNr]->isDown();
	 else 
	 	EBit=PushButton_EBit[ButtonNr]->isOn();	
   	CPU->SetBit(EINGANG,ButtonNr,EBit);
   }
 
	returnWert=CPU->SPS_Interpreter(BausteinName,BausteinNr);
 
 	if(showRun<100 && RunAzeige==false)
	{	RunAzeige=true;
		statusbar->message(i18n("Simulation: laeuft"),1000);
	}
	else if(showRun>200) 
	{	RunAzeige=false;
		showRun=0;
	}		
	if(SPS_RUN==false)
	{ // ms10Timer->stop();
		SimulationsTimer->stop();
		CPU->AByte[0]=0;
		CPU->AByte[1]=0;
		pAgStop_Rb->setChecked(true);
	}
	EBytes_LED_Anzeige();
   ABytes_LED_Anzeige();

}//ENDE SPS_ProgrammAufrufen_Timer()


void ksps::SPS_ProgrammAufrufen()
{ 	unsigned char ButtonNr;
	char EBit;
	BausteinName=OB;
  	BausteinNr=1;
  	for(ButtonNr=0;ButtonNr<=15;ButtonNr++)
  	{	if(ButtonNr<4)
			EBit=PushButton_EBit[ButtonNr]->isDown();
		else if(ButtonNr<8)
			EBit=!PushButton_EBit[ButtonNr]->isDown();
		else 
	 		EBit=PushButton_EBit[ButtonNr]->isOn();	
   	CPU->SetBit(EINGANG,ButtonNr,EBit);
	}
	returnWert=CPU->SPS_Interpreter(BausteinName,BausteinNr);
	if(SPS_RUN==false)
	{  //ms10Timer->stop();
		SimulationsTimer->stop();
		CPU->AByte[0]=0;
		CPU->AByte[1]=0;
		pAgStop_Rb->setChecked(true);
	}
	ABytes_LED_Anzeige();
   EBytes_LED_Anzeige();
}//ENDE SPS_ProgrammAufrufen



void ksps::NetzwerkText_SeicherAnfrodern(int NetzwerkNr,int AnzahlBytes)
{	if(Netzwerk_Text[NetzwerkNr]==NULL)
	{	Netzwerk_Text[NetzwerkNr]=new char[AnzahlBytes];
		memset(Netzwerk_Text[NetzwerkNr],0,sizeof(char)*AnzahlBytes);
	}
}//ENDE NetzwerkText_SeicherAnfrodern(int NetzwerNr)

void ksps::NetzwerkText_SeicherFreigeben(int NetzwerkNr)
{	if(Netzwerk_Text[NetzwerkNr]!=NULL)
	{  delete [] Netzwerk_Text[NetzwerkNr];
	   Netzwerk_Text[NetzwerkNr]=0;
	}
}//ENDE NetzwerkText_SeicherFreigeben(int NetzwerNr)

void ksps::SpsTextLaden(QString QDateipfadPlusDateiname_Wahl)
{ 	FILE *stream;
  	QString QStr,QBausteinName;
  	char CStr[80];
	unsigned int pos=0;
	char *pChar,*pStrNe;
	unsigned int datLen;
   MaxTextNetzwerkNr=0;
	if(QDateipfadPlusDateiname_Wahl.length()==0)
		QDateipfadPlusDateiname=fileName->getOpenFileName(QProjektpfad,
			"Programmbausteine (*.sps );;Alle Dateien (*.*)",this);
   else if(QDateipfadPlusDateiname_Wahl.length()>0)
		QDateipfadPlusDateiname=QDateipfadPlusDateiname_Wahl;
	if(QDateipfadPlusDateiname.length()!=0)
   {  PfadDateiname_zerlegen(QDateipfadPlusDateiname,QDateipfad,QDateiname);
		
		statusbar->message(QDateipfadPlusDateiname);
		stream = fopen(QDateipfadPlusDateiname,"rb");
		if(stream)
		{	fseek(stream, 0, SEEK_END);
			datLen = ftell(stream);
			fseek(stream, 0, SEEK_SET);
   		fread (CStr_zwischenSpeicher, 1, datLen, stream);
			fclose(stream);
			CStr_zwischenSpeicher[datLen] = 0;
		}
   	
	//	QStr="Bausteinname:"+QBausteinName;

		char *abStrBE;
		pChar=strtok(CStr_zwischenSpeicher,"\n");
		TextNetzwerkNr=0;
		while(pChar)
		{	pStrNe=strchr(pChar,'~');
			if(pStrNe!=NULL)
			{	BausteinTitelEditor->setText(++pStrNe);
				pChar=strtok(NULL,"\n");
			   if(pChar==NULL) 
					break;
			}
			pStrNe=strstr(pChar,"\tNE\t");
			if (pStrNe!=NULL)
		  	{  TextNetzwerkNr++;
				MaxTextNetzwerkNr=TextNetzwerkNr;
				NetzwerkText_SeicherAnfrodern(TextNetzwerkNr,ANZAHL_NETZWERK_SPEICHER);
				pChar=strchr(pChar,'#');
				if (pChar!=NULL)
				{	strcpy(Netzwerk_Text[TextNetzwerkNr],"\t");
					strcpy(Netzwerk_Text[TextNetzwerkNr],pChar);
					strcat(Netzwerk_Text[TextNetzwerkNr],"\n");
				}
				else
				{	strcpy(Netzwerk_Text[TextNetzwerkNr],"\t#");
					strcat(Netzwerk_Text[TextNetzwerkNr],"\n");
				}
			}
			else
			{	abStrBE=strstr(pChar,"BE");
			  	if(abStrBE==NULL)
				{  strcat(Netzwerk_Text[TextNetzwerkNr],pChar);
			   	strcat(Netzwerk_Text[TextNetzwerkNr],"\n");  
				}	
			}
		   pChar=strtok(NULL,"\n");
		}//ENDE	while(pChar)
		if(TextNetzwerkNr==0)
		{	statusbar->message(i18n("Konnte Baustein nicht laden! (Fehlerhafter Baustein)"),3000);
			return;
		}
		spinBox_text_NeNr->setMaxValue(MaxTextNetzwerkNr);
		TextNetzwerkNr=1;
		// If Abfrage damit die spinBox nur einmal aufgerufen wird 
		if(spinBox_text_NeNr->value()==0)
			spinBox_text_NeNr->setMinValue(TextNetzwerkNr);
		else if(TextNetzwerkNr==spinBox_text_NeNr->value())
			get_spinBox_text_NeNr_slot(TextNetzwerkNr);
		else
			spinBox_text_NeNr->setValue(TextNetzwerkNr);
		QBausteinName=QDateiname;
		pos=QBausteinName.find('.',0,false);
		if(pos>0) QStr=i18n("Bausteinname:")+QBausteinName.left(pos);
		QStr=" " + QBausteinName.left(pos);
		EditorBausteinUeberschrift_lbl->setText(QStr);
		sprintf(CStr," NE:%d",TextNetzwerkNr);
		EditorNetzwerkUeberschrift_lbl->setText(i18n(CStr));
		BausteinTitelEditor->setDisabled(false);
		NetzwerkTitelEditor->setDisabled(false);
		Editor->setPaper(Qt::white);
		Editor->setDisabled(false);
  		Editor->setFocus();
		TextBausteinVorhanden=true;
		statusbar->message(i18n("Der Bausteintext wurde geladen."),2000);
	}
	else
		statusbar->message(i18n("Konnte den Bausteintext nicht laden!"),7000);
}//ENDE SpsTextLaden()

void ksps::SpsTextSpeichern()
{  FILE *stream;
   QString QStr;
	char CStr[80];
	unsigned int laenge;
   int n;
	QDateipfadPlusDateiname=QProjektpfad+QDateiname;
//	QDateipfadPlusDateiname =fileName->getSaveFileName(QDateipfadPlusDateiname,"*.sps",this,"","Baustein speichern");
	if(QDateipfadPlusDateiname.length()!=0)
	{	Editor_InNertwerkTextRetten(TextNetzwerkNr); // Editor
		if(MaxTextNetzwerkNr>0)
		{	QStr="~" + BausteinTitelEditor->text() + "\n" ;
			strcpy(CStr_zwischenSpeicher,QStr);
			for(n=1;n<=MaxTextNetzwerkNr;n++)
		 	{	sprintf(CStr,"\tNE\t%d\t",n);
				strcat(CStr_zwischenSpeicher,CStr);
				strcat(CStr_zwischenSpeicher,Netzwerk_Text[n]);	
			}
		}
		if(!strstr(CStr_zwischenSpeicher,"BE"))
		{	strcat(CStr_zwischenSpeicher,"\tBE\n");
		}
		stream = fopen(QDateipfadPlusDateiname,"wb");
		if(stream)
		{ 	laenge=strlen(CStr_zwischenSpeicher);
			fwrite(CStr_zwischenSpeicher,sizeof(char),laenge, stream);
			fclose(stream);
		}
		statusbar->message(i18n("Der Bausteintext wurde gespeichert als: ")+QDateipfadPlusDateiname,10000);
	}
	else
		statusbar->message(i18n("Der Bausteintext kann nicht gespeichert werden!"),7000);
}//ENDE SpsTextSpeichern()

void ksps::SpsTextSpeichernAls()
{ 	FILE *stream;
	QString QStr;
	char CStr[80];
	int n,pos;
	unsigned int laenge;
	QDateipfadPlusDateiname =fileName->getSaveFileName(QProjektpfad,
	"Programm Bausteine (*.sps );;Alle Dateien (*.*)",this,"",
	i18n("Baustein speichern als: z.B. ob1, pb2, fb5, sb2 ?"));
	if(QDateipfadPlusDateiname.length()!=0)
	{	PfadDateiname_zerlegen(QDateipfadPlusDateiname,QDateipfad,QDateiname);
		QDateiname=QDateiname.lower();
		pos=QDateiname.find('.',0,true);
		if(pos==-1)
			 QDateiname=QDateiname+".sps";
		QDateipfadPlusDateiname=QDateipfad+QDateiname;
		Editor_InNertwerkTextRetten(TextNetzwerkNr); // Editor
		if(MaxTextNetzwerkNr>0)
		{	QStr="~" + BausteinTitelEditor->text() + "\n" ;
			strcpy(CStr_zwischenSpeicher,QStr);
			for(n=1;n<=MaxTextNetzwerkNr;n++)
		 	{	sprintf(CStr,"\tNE\t%d\t",n);
				strcat(CStr_zwischenSpeicher,CStr);
				strcat(CStr_zwischenSpeicher,Netzwerk_Text[n]);	
			}
		}
		if(!strstr(CStr_zwischenSpeicher,"BE"))
			strcat(CStr_zwischenSpeicher,"\tBE\n");
		stream = fopen(QDateipfadPlusDateiname,"wb");
		if(stream)
		{ 	laenge=strlen(CStr_zwischenSpeicher);
			fwrite(CStr_zwischenSpeicher,sizeof(char),laenge, stream);
			fclose(stream);
		}
		QBausteinName=QDateiname;
		pos=QBausteinName.find('.',0,false);
		if(pos>0) QStr="Beistein Name:"+QBausteinName.left(pos);
		QStr=" " + QBausteinName.left(pos);
		EditorBausteinUeberschrift_lbl->setText(QStr);
		sprintf(CStr," NE:%d",TextNetzwerkNr);
		EditorNetzwerkUeberschrift_lbl->setText(i18n(CStr));
	}
	else
		statusbar->message(i18n("Die Datei kann nicht gespeichert werden!"),7000);
}//ENDE SpsTextSpeichernAls()

void ksps::SpsNeuerBaustein()
{  FILE *stream;
	QString Qstr,QBausteinName;
	char CStr[80];
	int pos;
	MaxTextNetzwerkNr=TextNetzwerkNr=1;
	NetzwerkText_SeicherAnfrodern(TextNetzwerkNr,ANZAHL_NETZWERK_SPEICHER);
	QDateipfadPlusDateiname =fileName->getSaveFileName(QProjektpfad,
		"Programmbausteine (*.sps );;Alle Dateien (*.*)",this,"",
		i18n("Neuer Baustein:  Geben Sie den Namen ein:"
		"z.B. ob1.sps, pb2.sps, sb3.sps "));
  statusbar->message(QDateipfadPlusDateiname);
	if (QDateipfadPlusDateiname.length()!=0)
  	{	PfadDateiname_zerlegen(QDateipfadPlusDateiname,QDateipfad,QDateiname);
		QDateiname=QDateiname.lower();
		pos=QDateiname.find('.',0,false);
		if(pos==-1) QDateiname=QDateiname+".sps";
   	QDateipfadPlusDateiname=QDateipfad+QDateiname;
		statusbar->message(QDateipfadPlusDateiname);
		if(QDateipfadPlusDateiname.length()!=0)
		{  stream = fopen(QDateipfadPlusDateiname,"wb");
			if(stream)
			{ 	QStr=("~\n\tNE\t1\t\t#\n\tBE\n");
			   fwrite(QStr,sizeof(char),QStr.length(), stream);
				fclose(stream);
			}
		}
	}
	spinBox_text_NeNr->setMaxValue(TextNetzwerkNr);
	spinBox_text_NeNr->setMinValue(TextNetzwerkNr);
	spinBox_text_NeNr->setValue(TextNetzwerkNr);
   
	QBausteinName=QDateiname;
	pos=QBausteinName.find('.',0,false);
	if(pos>0) QStr="Baustein Name:"+QBausteinName.left(pos);
	QStr=" " + QBausteinName.left(pos);
	EditorBausteinUeberschrift_lbl->setText(QStr);
	sprintf(CStr," NE:%d",TextNetzwerkNr);
	EditorNetzwerkUeberschrift_lbl->setText(i18n(CStr));

	
	BausteinTitelEditor->clear();
  	NetzwerkTitelEditor->clear();
	Editor->clear();
	BausteinTitelEditor->setDisabled(false);
	NetzwerkTitelEditor->setDisabled(false);
	Editor->setPaper(Qt::white);
	Editor->setDisabled(false);
  	Editor->setFocus();
	TextBausteinVorhanden=true;
}//ENDE ksps::SpsNeuerBaustein()

void ksps::NeuesProjektVorbereiten()
{	int z,s,n;
	char CStr[256];
	spinBox_text_NeNr->setMaxValue(0);
	MaxTextNetzwerkNr=TextNetzwerkNr=0;
	for(n=0;n<256;n++)
		NetzwerkText_SeicherFreigeben(n);
	Editor->clear();
	FehlerListBox->clear();
	EditorBausteinUeberschrift_lbl->setText(" BA: ?");
	BausteinTitelEditor->clear();
	EditorNetzwerkUeberschrift_lbl->setText(" NE: ?");
	NetzwerkTitelEditor->clear();
	for(n=0;n<=15;n++)
	{ 	LEdit_EBit[n]->clear(); 
		LEdit_ABit[n]->clear(); 
	}
	for(s=0;s<pEAM_KommentarTabelle->numCols();s++)
	{	for(z=0;z<pEAM_KommentarTabelle->numRows();z++)
		{	if(s==0)
			{	sprintf(CStr,"E%d.%d",z/8,z%8);
				pEAM_KommentarTabelle->setText(z,s,CStr);
			}
			else	if(s==1) 
			{	sprintf(CStr,"A%d.%d",z/8,z%8);
				pEAM_KommentarTabelle->setText(z,s,CStr);
			}
			else	if(s==2) 
			{	sprintf(CStr,"M%d.%d",z/8,z%8);
				pEAM_KommentarTabelle->setText(z,s,CStr);
			}
		}
	}
	for(s=0;s<pTZ_ObPbFbSbKommentarTabelle->numCols();s++)
	{	for(z=0;z<pTZ_ObPbFbSbKommentarTabelle->numRows();z++)
		{	if(s==0)
			{ sprintf(CStr,"T%d",z);
			pTZ_ObPbFbSbKommentarTabelle->setText(z,s,CStr);
			}
			else if(s==1)
			{ sprintf(CStr,"Z%d",z);
			pTZ_ObPbFbSbKommentarTabelle->setText(z,s,CStr);
			}
			else
				pTZ_ObPbFbSbKommentarTabelle->clearCell(z,s); 
		}
	}
}//ENDE  NeuesProjektVorbereiten()

void ksps::NeuesProjektErzeugen()
{  FILE *stream;
	QString DateiQStr,QStr,QPfad,QDateiName,QPfadDatei,QProjektKennungPlusName;
 	unsigned int laenge,Zeile,AnzahlZeilen;
	int pos,n;
	char CStr[256],ZwStr[256];
   char ZeileStr[10][80];
   char Datum[20],Zeit[20];
	 homePath=path.homeDirPath(); 
	 QProjektpfadPlusProjektname = fileName->getSaveFileName(homePath,
    "Projekt(*.prj)",this,0,i18n("Neues Projekt: Geben Sie den Namen ein:"));
  if (QProjektpfadPlusProjektname.length()!=0)
  {	NeuesProjektVorbereiten();
      pos=QProjektpfadPlusProjektname.find('.',0,true);
		if(pos>0)
			QProjektpfadPlusProjektname=QProjektpfadPlusProjektname.left(pos);
  		PfadDateiname_zerlegen(QProjektpfadPlusProjektname,QProjektpfad,QProjektname);
	
	  	ProjektHomePath=QProjektpfad;
	  	QProjektname=QProjektname.lower();
	  	chdir(QProjektpfad);
			mkdir(QProjektname,S_IRWXU);
			QProjektpfad=QProjektpfad+QProjektname + "/";
			QProjektname=QProjektname + ".prj";
			QProjektpfadPlusProjektname=QProjektpfad + QProjektname;		
			strcpy(Projekt_Kennung,PROJEKT_KENNUNG);
			QProjektKennungPlusName=QProjektKennungPlusName+Projekt_Kennung+QProjektname;
			statusbar->message(QProjektpfad);
			strcpy(ZeileStr[0],QProjektKennungPlusName);
			strcat(ZeileStr[0],"\n");
			strcpy(ProjektNameStr,ZeileStr[0]);
			Date(Datum);
			sprintf(ZeileStr[1],"Datum>%s\n",Datum);
			strcpy(DatumStr,ZeileStr[1]);
			Time(Zeit);
			sprintf(ZeileStr[2],"Uhrzeit>%s\n",Zeit);
			strcpy(UhrzeitStr,ZeileStr[2]);
			sprintf(ZeileStr[3],"Autor von ksps>%s\n","Burkhard Brauer  (*** Elektromeister ***)");
			strcpy(AutorStr,ZeileStr[3]);
			stream = fopen(QProjektpfadPlusProjektname,"wb");
			if(stream)
			{ AnzahlZeilen=Editor->numLines();
				for(Zeile=0; Zeile<=3; Zeile++)
				{ strcpy(CStr,ZeileStr[Zeile]);
				laenge=strlen(CStr);
				fputs(CStr,stream);
				}
			for(n=0;n<=15; n++)
			{	strcpy(ZwStr,LEdit_EBit[n]->text());
			   sprintf(CStr,"EBit_%03d>%s\n",n,ZwStr);
				laenge=strlen(CStr);
				fputs(CStr,stream);
			}
			for(n=0;n<=15; n++)
			{  strcpy(ZwStr,LEdit_ABit[n]->text());
				sprintf(CStr,"ABit_%03d>%s\n",n,ZwStr);
				laenge=strlen(CStr);
				fputs(CStr,stream);
			}
			for(n=0;n<=255; n++)
			{ 	sprintf(CStr,"EBit%03d_Kommentar>%s\n",n,pEingaenge_Kommentar[n]);
				fputs(CStr,stream);
			}
			for(n=0;n<=255; n++)
			{	sprintf(CStr,"ABit%03d_Kommentar>%s\n",n,pAusgaenge_Kommentar[n]);
				fputs(CStr,stream);
			}
			for(n=0;n<=255; n++)
			{	sprintf(CStr,"MBit%03d_Kommentar>%s\n",n,pMerker_Kommentar[n]);
				fputs(CStr,stream);
			}
			for(n=0;n<=255; n++)
			{ 	sprintf(CStr,"Timer%03d_Kommentar>%s\n",n,pTimer_Kommentar[n]);
				fputs(CStr,stream);
			}
			for(n=0;n<=255; n++)
			{ 	sprintf(CStr,"Zaehler%03d_Kommentar>%s\n",n,pZaehler_Kommentar[n]);
				fputs(CStr,stream);
			}
			fclose(stream);
			MenuText->setDisabled(false);
			MenuAG->setDisabled(false);
		}
	}
  	else
	  statusbar->message(i18n("Kann kein Projekt erzeugen!"));
}//ENDE NeuesProjektErzeugen()

void ksps::ProjektDatenSpeichern()
{	FILE *stream;
	QString DateiQStr,QStr,QPfad,QDateiName;
 	unsigned int n;
	char CStr[256],ZwStr[256];
	if (QProjektpfadPlusProjektname.length()!=0 )
   {	stream = fopen(QProjektpfadPlusProjektname,"wb+");
 		if(stream)
		{  fputs(ProjektNameStr,stream);
			fputs(DatumStr,stream);
			fputs(UhrzeitStr,stream);
			fputs(AutorStr,stream);
			for(n=0;n<=15; n++)
			{	strcpy(ZwStr,LEdit_EBit[n]->text());
			   sprintf(CStr,"EBit_%03d>%s\n",n,ZwStr);
				fputs(CStr,stream);
			}
			for(n=0;n<=15; n++)
			{  strcpy(ZwStr,LEdit_ABit[n]->text());
				sprintf(CStr,"ABit_%03d>%s\n",n,ZwStr);
				fputs(CStr,stream);
			}
			for(n=0;n<=255; n++)
			{ 	sprintf(CStr,"EBit%03d_Kommentar>%s\n",n,pEingaenge_Kommentar[n]);
				fputs(CStr,stream);
			}
			for(n=0;n<=255; n++)
			{	sprintf(CStr,"ABit%03d_Kommentar>%s\n",n,pAusgaenge_Kommentar[n]);
				fputs(CStr,stream);
			}
			for(n=0;n<=255; n++)
			{	sprintf(CStr,"MBit%03d_Kommentar>%s\n",n,pMerker_Kommentar[n]);
				fputs(CStr,stream);
			}
			for(n=0;n<=255; n++)
			{ 	sprintf(CStr,"Timer%03d_Kommentar>%s\n",n,pTimer_Kommentar[n]);
				fputs(CStr,stream);
			}
			for(n=0;n<=255; n++)
			{ 	sprintf(CStr,"Zaehler%03d_Kommentar>%s\n",n,pZaehler_Kommentar[n]);
				fputs(CStr,stream);
			}
			for(n=0;n<=255; n++)
			{ 	sprintf(CStr,"OB%03d_Kommentar>%s\n",n,pOB_Kommentar[n]);
				fputs(CStr,stream);
			}
			for(n=0;n<=255; n++)
			{ 	sprintf(CStr,"PB%03d_Kommentar>%s\n",n,pPB_Kommentar[n]);
				fputs(CStr,stream);
			}
			for(n=0;n<=255; n++)
			{ 	sprintf(CStr,"FB%03d_Kommentar>%s\n",n,pFB_Kommentar[n]);
				fputs(CStr,stream);
			}
			for(n=0;n<=255; n++)
			{ 	sprintf(CStr,"SB%03d_Kommentar>%s\n",n,pSB_Kommentar[n]);
				fputs(CStr,stream);
			}
			fclose(stream);
		}
		else
		{ statusbar->message(i18n("Kann die Daten nicht Speichern!"));
		}
	}
   else
		statusbar->message(i18n("Kann die Daten nicht Speichern!"));
}//ENDE void ProjektDatenSpeichern()

bool ksps::ProjektLaden(QString Pfad)
{ FILE *stream;
  QString DateiQStr,QStr;
	int n,StrLen;
  char *pStr, Str[80];
  QProjektpfadPlusProjektname=fileName->getOpenFileName(Pfad,DateiFilter
		,this,"",i18n("Projekt oeffnen"));
  PfadDateiname_zerlegen(QProjektpfadPlusProjektname,QProjektpfad,QProjektname);

 	if (QProjektpfadPlusProjektname.length()!=0)
  { ProjektHomePath=QProjektpfad;
	  NeuesProjektVorbereiten();
  		statusbar->message(DateiQStr);
		stream = fopen(QProjektpfadPlusProjektname,"rb");//rb+
 		if(stream)
		{  fgets(ProjektNameStr,80,stream);
      	StrLen=strlen(PROJEKT_KENNUNG);
			strncpy(Projekt_Kennung,ProjektNameStr,StrLen);
			if(strcmp(Projekt_Kennung,PROJEKT_KENNUNG)!=0)
		   {  fclose(stream);
				statusbar->message(i18n("Kann das Projekt nicht laden!"));
 				return false;
			}
			else
			{ MenuText->setDisabled(false);
			  MenuAG->setDisabled(false);
			}
			statusbar->message(ProjektNameStr);
			fgets(DatumStr,80,stream);
			fgets(UhrzeitStr,80,stream);
			fgets(AutorStr,80,stream);
			for(n=0;n<=15; n++)
			{  fgets(Str,80,stream);
            pStr=strtok(Str,">");
				pStr=strtok(NULL,">");
				if(pStr!=NULL)
				{	ZeichenEntfernen(pStr,'\n');
					LEdit_EBit[n]->setText(pStr);
				}
			}
			for(n=0;n<=15;n++)
			{  fgets(Str,80,stream);
            pStr=strtok(Str,">");
				pStr=strtok(NULL,">");
				if(pStr!=NULL)
				{	ZeichenEntfernen(pStr,'\n');
					LEdit_ABit[n]->setText(pStr);
				}
			}
			
			for(n=0;n<=255; n++)
			{ 	fgets(Str,80,stream);
				pStr=strtok(Str,">");
				pStr=strtok(NULL,">");
				if(pStr!=NULL)
				{	ZeichenEntfernen(pStr,'\n');
					strcpy(pEingaenge_Kommentar[n],pStr);
				}
			}
			for(n=0;n<=255; n++)
			{	fgets(Str,80,stream);
				pStr=strtok(Str,">");
				pStr=strtok(NULL,">");
				if(pStr!=NULL)
				{	ZeichenEntfernen(pStr,'\n');
					strcpy(pAusgaenge_Kommentar[n],pStr);
				}
			}
			for(n=0;n<=255; n++)
			{	fgets(Str,80,stream);
				pStr=strtok(Str,">");
				pStr=strtok(NULL,">");
				if(pStr!=NULL)
				{	ZeichenEntfernen(pStr,'\n');
					strcpy(pMerker_Kommentar[n],pStr);
				}
			}
			for(n=0;n<=255; n++)
			{ 	fgets(Str,80,stream);
				pStr=strtok(Str,">");
				pStr=strtok(NULL,">");
				if(pStr!=NULL)
				{	ZeichenEntfernen(pStr,'\n');
					strcpy(pTimer_Kommentar[n],pStr);
				}
			}
			for(n=0;n<=255; n++)
			{ 	fgets(Str,80,stream);
				pStr=strtok(Str,">");
				pStr=strtok(NULL,">");
				if(pStr!=NULL)
				{	ZeichenEntfernen(pStr,'\n');
					strcpy(pZaehler_Kommentar[n],pStr);
				}
			}
			for(n=0;n<=255; n++)
			{ 	fgets(Str,80,stream);
				pStr=strtok(Str,">");
				pStr=strtok(NULL,">");
				if(pStr!=NULL)
				{	ZeichenEntfernen(pStr,'\n');
					strcpy(pOB_Kommentar[n],pStr);
				}
			}
			for(n=0;n<=255; n++)
			{ 	fgets(Str,80,stream);
				pStr=strtok(Str,">");
				pStr=strtok(NULL,">");
				if(pStr!=NULL)
				{	ZeichenEntfernen(pStr,'\n');
					strcpy(pPB_Kommentar[n],pStr);
				}
			}
			for(n=0;n<=255; n++)
			{ 	fgets(Str,80,stream);
				pStr=strtok(Str,">");
				pStr=strtok(NULL,">");
				if(pStr!=NULL)
				{	ZeichenEntfernen(pStr,'\n');
					strcpy(pFB_Kommentar[n],pStr);
				}
			}
			for(n=0;n<=255; n++)
			{ 	fgets(Str,80,stream);
				pStr=strtok(Str,">");
				pStr=strtok(NULL,">");
				if(pStr!=NULL)
				{	ZeichenEntfernen(pStr,'\n');
					strcpy(pSB_Kommentar[n],pStr);
				}
			}
			fclose(stream);
		   return true; 
		}
	}
	else
		statusbar->message(i18n("Kann die Daten nicht laden!"),7000);
	return false;
}//ENDE ProjektLaden()

void ksps::MenueItem(int MenuPunkt)
{	 switch(MenuPunkt)
	{  case M_FORMATIEREN: // or [F2]
			Ganzen_TextFormatieren();
		case M_FEHLER_PRUEFEN:
			//Compiler(char* CStr_zwischenSpeicher)
		break;
		break;	
		case M_NEUES_PROJEKT:
				NeuesProjektErzeugen();
		break;
		case M_PROJEKT_DATEN_SPEICHERN:
				if(strcmp(Projekt_Kennung,PROJEKT_KENNUNG)==0)
				{	getTabellenKommentarEAMTZ();
					ProjektDatenSpeichern();
				}
				else
					statusbar->message(i18n("Sie muessen zuerst ein Projekt oeffnen!"),5000);
		break;
		case M_POJEKT_LADEN:
			ProjektLaden(ProjektHomePath);
			setTabellenKommentarEAMTZ();
		break;
		case M_POJEKT_LADEN_U_START:
			ProjektlLadenToAgUStarten(ProjektHomePath);
		break;
		case M_BEISPIEL_POJEKT_LADEN: // Beispielprojekt laden ins AG und starten
			ProjektlLadenToAgUStarten( data_path );
		break;		
		case M_QUIT:
			close();
		break;
		case M_TEXT_LADEN:
			if(strcmp(Projekt_Kennung,PROJEKT_KENNUNG)==0)
			{	SpsTextLaden("");
				TabWidget->showPage(pEditorWidget);
			}
			else
				statusbar->message(i18n("Sie muessen zuerst ein Projekt oeffnen!"),5000);
		break;
		case M_TEXT_SPEICHERN:
				if(strcmp(Projekt_Kennung,PROJEKT_KENNUNG)==0)
				{
					SpsTextSpeichern();
				}
				else
					statusbar->message(i18n("Sie muessen zuerst ein Projekt oeffnen!"),5000);
		break;
		case M_TEXT_SPEICHERN_ALS:
			 if(strcmp(Projekt_Kennung,PROJEKT_KENNUNG)==0)
			 {	statusbar->message(i18n("Der Text Baustein wird gespeichert!"),2000);
			 	SpsTextSpeichernAls();
    		 }
			 else
			 	statusbar->message(i18n("Sie muessen zuerst ein Projekt oeffnen!"),5000);
		break;
	   case M_NEUER_BAUSTEIN:
				SpsNeuerBaustein();
		break;
		case M_BAUSTEIN_TRANSVER:
			if(strcmp(Projekt_Kennung,PROJEKT_KENNUNG)==0)
			{	Baustein_ins_AG_Laden();
				AnzeigeTimer->start(1,true);
			}
			else
				statusbar->message(i18n("Sie muessen zuerst ein Projekt oeffnen!"),5000);
		break;
		case M_ALLE_BAUSTEINE_TRANSVER:
			if(strcmp(Projekt_Kennung,PROJEKT_KENNUNG)==0)
			{	Alle_Bausteine_ins_AG_laden();
				AnzeigeTimer->start(1,true);
			}
			else
				statusbar->message(i18n("Sie muessen zuerst ein Projekt oeffnen!"),5000);
		break;
		case M_AG_NEUSTART:
			if(strcmp(Projekt_Kennung,PROJEKT_KENNUNG)==0)
			{ 	 CPU->AG_Neustart();
			}
			else
				statusbar->message(i18n("Sie muessen zuerst ein Projekt oeffnen!"),5000);
		break;
		case M_AG_LOESCHEN:
			if(strcmp(Projekt_Kennung,PROJEKT_KENNUNG)==0)
			{	AG_Loeschen();
			}
			else
				statusbar->message(i18n("Sie muessen zuerst ein Projekt oeffnen!"),5000);
		break;
	}
}//ENDE MenueItem(unsigned int MenuPunkt)

void ksps::get_spinBox_text_NeNr_slot(int AndereNetzwerkNr)
{	char CStr[80];	
	if(AndereNetzwerkNr>0 && MaxTextNetzwerkNr>=AndereNetzwerkNr)
	{	if(TextNetzwerkNr!=AndereNetzwerkNr)
			Editor_InNertwerkTextRetten(TextNetzwerkNr);
		NetzwerkTextToEditor(AndereNetzwerkNr);
		TextNetzwerkNr=AndereNetzwerkNr;
		sprintf(CStr," NE:%d",TextNetzwerkNr);
		EditorNetzwerkUeberschrift_lbl->setText(i18n(CStr));
	}
}//ENDE get_spinBox_text_NeNr_slot(int NeueNetzwerkNr)

void ksps::TAnzeige() // AnzeigeTimer
{  bool anzeigen;
	char Str[256];
	switch(Status_BausteinName)
	{	case OB:
			anzeigen=OB_Infos[Status_BausteinNr].vorhanden;
		break;
		case PB:
			anzeigen=PB_Infos[Status_BausteinNr].vorhanden;
		break;
		case FB:
			anzeigen=FB_Infos[Status_BausteinNr].vorhanden;
		break;
		case SB:
			anzeigen=SB_Infos[Status_BausteinNr].vorhanden;
		break;
		default:
			anzeigen=false;
	}

   if(anzeigen)
	{ 	BausteinBefehlsfolge(Status_BausteinName,Status_BausteinNr,Status_Netzwerk_Nr);
		sprintf(Str," Netzwerk:%d  %s",Status_Netzwerk_Nr,NetzwerkUeberschrift_Anzeige);
		statusNetzwerkUeberschrift_Lbl->setText(Str);
		BefehleStrings();
		StatusAnzeigePaint();
	}
}//ENDE TAnzeige()



void ksps::set_status_spinBoxValue(int index)
{  status_spinBox_AlteNetzwerkNr=0;
   status_spinBox_NeNr_slot(index);
}

void ksps::statusComboBox_slot(int index) //fuer StatusAnzeige
{  QString BausteinPlusNr,ArtBaustein,NrBaustein;
	char Str[256];
  	int MaxNetzwerkNr=0;
	ComboBox_AlterIndex=index;

	BausteinPlusNr=ComboBox->text(ComboBox_AlterIndex);
	ComboBox->setCurrentItem(index);
	statusbar->message(BausteinPlusNr);
	ArtBaustein=BausteinPlusNr.left(2);
   NrBaustein=BausteinPlusNr.mid(2,3);
   if(ArtBaustein.length()>0)
	{	strcpy(Str,NrBaustein);
		Status_BausteinNr=atoi(Str);
		Status_Netzwerk_Nr=1;
		if(ArtBaustein.compare("ob")==0)
		{	Status_BausteinName=OB;
			MaxNetzwerkNr=OB_Infos[Status_BausteinNr].AnzahlNetzwerke;
		}
		else if(ArtBaustein.compare("pb")==0)
		{	Status_BausteinName=PB;
			MaxNetzwerkNr=PB_Infos[Status_BausteinNr].AnzahlNetzwerke;
		}
		else if(ArtBaustein.compare("fb")==0)
		{	Status_BausteinName=FB;
			MaxNetzwerkNr=FB_Infos[Status_BausteinNr].AnzahlNetzwerke;
		}
		else if(ArtBaustein.compare("sb")==0)
		{	Status_BausteinName=SB;
			MaxNetzwerkNr=SB_Infos[Status_BausteinNr].AnzahlNetzwerke;
		}
	
		switch(Status_BausteinName)
		{	case OB:
				if(pOB_BausteinUeberschrift[Status_BausteinNr]!=NULL)	
				{	sprintf(BausteinUeberschrift_Anzeige," OB%d  %s",
								Status_BausteinNr,pOB_BausteinUeberschrift[Status_BausteinNr]);
				}
				else
				sprintf(BausteinUeberschrift_Anzeige," OB%d",Status_BausteinNr);
			break;
			case PB:
					if(pPB_BausteinUeberschrift[Status_BausteinNr]!=NULL)
					{	sprintf(BausteinUeberschrift_Anzeige," PB%d  %s",
									Status_BausteinNr,pPB_BausteinUeberschrift[Status_BausteinNr]);
					}
					else
						sprintf(BausteinUeberschrift_Anzeige," PB%d",Status_BausteinNr);
			break;
			case FB:
					if(pFB_BausteinUeberschrift[Status_BausteinNr]!=NULL)
					{	sprintf(BausteinUeberschrift_Anzeige," FB%d  %s",
									Status_BausteinNr,pFB_BausteinUeberschrift[Status_BausteinNr]);
					}
					else
						sprintf(BausteinUeberschrift_Anzeige," FB%d",Status_BausteinNr);
			break;
			case SB:
					if(pSB_BausteinUeberschrift[Status_BausteinNr]!=NULL)
					{	sprintf(BausteinUeberschrift_Anzeige," SB%d  %s",
									Status_BausteinNr,pSB_BausteinUeberschrift[Status_BausteinNr]);
					}
					else
						sprintf(BausteinUeberschrift_Anzeige," SB%d",Status_BausteinNr);
			break;
			default:
					*BausteinUeberschrift_Anzeige=0;
		}
		statusBausteinUeberschrift_Lbl->setText(BausteinUeberschrift_Anzeige);
		spinBoxStatus_NE_Nr->setMinValue(1);
		spinBoxStatus_NE_Nr->setMaxValue(MaxNetzwerkNr);
		set_status_spinBoxValue(1);
		TAnzeige();
		Ausgabe_geaendert=true;
	}
}//ENDE statusComboBox_slot(unsigned int index)

void ksps::statusComboBox_ttySn_slot(int index) //fuer Stat
{  switch(index)
	{	case 0:	//Kein RS232
			RS232_Aktive=false;
			ttySx->close_ttySn();
		break;
		case 1:
			RS232_Aktive=false;
			ttySx->close_ttySn();
			if(ttySx->Open_ttySn(dev_ttyS0,B9600))	
				RS232_Aktive=true;
		break;
		case 2:
			RS232_Aktive=false;
			ttySx->close_ttySn();
			if(ttySx->Open_ttySn(dev_ttyS0,B19200))	
				RS232_Aktive=true;
		break;
		case 3:
			RS232_Aktive=false;
			ttySx->close_ttySn();
			if(ttySx->Open_ttySn(dev_ttyS0,B38400))	
				RS232_Aktive=true;
		break;
		case 4:
			RS232_Aktive=false;
			ttySx->close_ttySn();
			if(ttySx->Open_ttySn(dev_ttyS1,B9600))	
				RS232_Aktive=true;
		break;
		case 5:
			RS232_Aktive=false;
			ttySx->close_ttySn();
			if(ttySx->Open_ttySn(dev_ttyS1,B19200))	
				RS232_Aktive=true;
		break;
		case 6:
			RS232_Aktive=false;
			ttySx->close_ttySn();
			if(ttySx->Open_ttySn(dev_ttyS1,B38400))	
				RS232_Aktive=true;
		break;
		case 7:
			RS232_Aktive=false;
			ttySx->close_ttySn();
			if(ttySx->Open_ttySn(dev_ttyS2,B9600))	
				RS232_Aktive=true;
		break;
		case 8:
			RS232_Aktive=false;
			ttySx->close_ttySn();
			if(ttySx->Open_ttySn(dev_ttyS2,B19200))	
				RS232_Aktive=true;
		break;
		case 9:
			RS232_Aktive=false;
			ttySx->close_ttySn();
			if(ttySx->Open_ttySn(dev_ttyS2,B38400))	
				RS232_Aktive=true;
		break;
		case 10:
			RS232_Aktive=false;
			ttySx->close_ttySn();
			if(ttySx->Open_ttySn(dev_ttyS3,B9600))	
				RS232_Aktive=true;
		break;
		case 11:
			RS232_Aktive=false;
			ttySx->close_ttySn();
			if(ttySx->Open_ttySn(dev_ttyS3,B19200))	
				RS232_Aktive=true;
		break;
		case 12:
			RS232_Aktive=false;
			ttySx->close_ttySn();
			if(ttySx->Open_ttySn(dev_ttyS3,B38400))	
				RS232_Aktive=true;
		break;
	}//Ende switch(index)

}//ENDE statusComboBox_ttySn_slot(int index) /

void ksps::status_spinBox_NeNr_slot(int NetwerkNr)//fuer StatusAnzeige
{   int MaxNetzwerkNr=0;
	 char Str[256];
	 
	 if(status_spinBox_AlteNetzwerkNr!=NetwerkNr)
	 {	status_spinBox_AlteNetzwerkNr=NetwerkNr;
	 	if(NetwerkNr==0) 
			return;
		Status_Netzwerk_Nr=NetwerkNr;
		switch(Status_BausteinName)
		{	case OB:
			MaxNetzwerkNr=OB_Infos[Status_BausteinNr].AnzahlNetzwerke;
			if(pOB_NetzwerkUeberschrift[Status_BausteinNr][Status_Netzwerk_Nr]) 
				strcpy(NetzwerkUeberschrift_Anzeige,pOB_NetzwerkUeberschrift[Status_BausteinNr][Status_Netzwerk_Nr]);
				
			break;
			case PB:
				MaxNetzwerkNr=PB_Infos[Status_BausteinNr].AnzahlNetzwerke;
				if(pPB_NetzwerkUeberschrift[Status_BausteinNr][Status_Netzwerk_Nr])
					strcpy(NetzwerkUeberschrift_Anzeige,pPB_NetzwerkUeberschrift[Status_BausteinNr][Status_Netzwerk_Nr]);
			break;
			case FB:
				MaxNetzwerkNr=FB_Infos[Status_BausteinNr].AnzahlNetzwerke;
				if(pFB_NetzwerkUeberschrift[Status_BausteinNr][Status_Netzwerk_Nr])
					strcpy(NetzwerkUeberschrift_Anzeige,pFB_NetzwerkUeberschrift[Status_BausteinNr][Status_Netzwerk_Nr]);
			break;
			case SB:
				MaxNetzwerkNr=SB_Infos[Status_BausteinNr].AnzahlNetzwerke;
				if(pSB_NetzwerkUeberschrift[Status_BausteinNr][Status_Netzwerk_Nr])
					strcpy(NetzwerkUeberschrift_Anzeige,pSB_NetzwerkUeberschrift[Status_BausteinNr][Status_Netzwerk_Nr]);
			break;
			default:
				MaxNetzwerkNr=1;
		}
		if(NetwerkNr<=MaxNetzwerkNr)
		{	Status_Netzwerk_Nr=NetwerkNr;
			
			sprintf(Str," Netzwerk:%d  %s",Status_Netzwerk_Nr,NetzwerkUeberschrift_Anzeige);
			statusNetzwerkUeberschrift_Lbl->setText(Str);
		}
		TAnzeige();
		Ausgabe_geaendert=true;
	}//END IF (AlteNetzwerkNr==NetwerkNr)
} //ENDE status_spinBox_NeNr_slot(unsigned int NetwerkNr)

void ksps::StartStopButton_Rb(int ButtonNr)// Start / Stop
{  switch(ButtonNr)
   { case 1: statusbar->message(i18n("Simulation: Run's"));
	   		WorkThread.aktiv=true;
				pAgRun_Rb->setChecked(true);
				//ms10Timer->start(10,false);
				SimulationsTimer->start(SimulationAlle_ms,false);
				SPS_RUN=true;
	  			
	  break;
     case 2: statusbar->message(i18n("Simulation: Stop"),3000);
			WorkThread.aktiv=false;
			pAgStop_Rb->setChecked(true);
			//ms10Timer->stop();
			SimulationsTimer->stop();
				SPS_RUN=false;
				TAnzeige();   
 				CPU->AByte[0]=0;
    			CPU->AByte[1]=0;
				AB_Port[0]=0;
				AB_Port[1]=0;
				EB_Port[2]=0;
				EB_Port[3]=0;
				ABytes_LED_Anzeige();
				EBytes_LED_Anzeige();
	  break;
    }
}//ENDE StartStopButton_Rb(unsigned int ButtonNr)

void ksps:: ButtonHexDez_Rb(int ButtonNr)	
{ 	AkkuDarstellung=ButtonNr;// Dez/Hex/Kommentar
	switch(ButtonNr)
	{	case 1:
		case 2:
			Akku1_2Komentar_lbl->setText(i18n(" Akku1     Akku2"));
		break;
		case 3:
			Akku1_2Komentar_lbl->setText(i18n("Kommentar"));
		break;
	}
	TAnzeige();
}//ENDE ButtonHD(int buttonNr)

void ksps::ScrollVer(int VerPos)
{ 	offsetZeile=VerPos;
   StatusAnzeigePaint();
	//TextAusgabe();
}

void ksps::neuesNetzwerkBtn_clicked() // Netzwerk  anfuegen
{ 	if(TextBausteinVorhanden)
	{	Editor_InNertwerkTextRetten(TextNetzwerkNr);
		NetzwerkTitelEditor->clear();
		if (TextNetzwerkNr<255) 
		{	MaxTextNetzwerkNr++;
			TextNetzwerkNr=MaxTextNetzwerkNr;
			NetzwerkText_SeicherAnfrodern(TextNetzwerkNr,ANZAHL_NETZWERK_SPEICHER);
			spinBox_text_NeNr->setMaxValue(MaxTextNetzwerkNr);
			spinBox_text_NeNr->setValue(TextNetzwerkNr); // ruft die spinBox_text_NeNr() auf
		}
		else 
			statusbar->message(i18n("Max. 255 Netzwerke erlaubt."),3000);
	}
	else
		statusbar->message(i18n("You must first load or create a unit  e.g. ob1"),7000);
}// ENDE neuesNetzwerkBtn_clicked()



void ksps::einfuegenNetzwerk_clicked() // vor Netzwerk einfuegen
{	int n;
 	if(TextBausteinVorhanden)
	{	MaxTextNetzwerkNr++;
		Editor_InNertwerkTextRetten(TextNetzwerkNr);
		NetzwerkText_SeicherAnfrodern(MaxTextNetzwerkNr,ANZAHL_NETZWERK_SPEICHER);
		for(n=MaxTextNetzwerkNr;n>TextNetzwerkNr;n--)
			strcpy(Netzwerk_Text[n],Netzwerk_Text[n-1]);	
		memset(Netzwerk_Text[TextNetzwerkNr],0,sizeof(char)*ANZAHL_NETZWERK_SPEICHER);
		spinBox_text_NeNr->setMaxValue(MaxTextNetzwerkNr);
		NetzwerkTitelEditor->clear();
		Editor->clear();
	}
	else
		statusbar->message(i18n("You must first load or create a unit  e.g. ob1"),7000);
}//ENDE einfuegenNetzwerk_clicked()

void ksps::loescheNetzwerk_clicked()
{	short n;
	if(TextBausteinVorhanden)
	{	if(MaxTextNetzwerkNr>TextNetzwerkNr)
		{	for(n=TextNetzwerkNr;n<MaxTextNetzwerkNr;n++)
				strcpy(Netzwerk_Text[n],Netzwerk_Text[n+1]);	
			memset(Netzwerk_Text[MaxTextNetzwerkNr],0,sizeof(char)*10000);
			MaxTextNetzwerkNr--;
			spinBox_text_NeNr->setMaxValue(MaxTextNetzwerkNr);
			NetzwerkTextToEditor(TextNetzwerkNr);
		}
		else if(TextNetzwerkNr>1 && MaxTextNetzwerkNr==TextNetzwerkNr)
		{	memset(Netzwerk_Text[TextNetzwerkNr],0,sizeof(char)*10000);
			MaxTextNetzwerkNr--;
			TextNetzwerkNr=MaxTextNetzwerkNr;
			// ruft die spinBox_text_NeNr->setMaxValue() auf wenn MaxValue < Value
			spinBox_text_NeNr->setMaxValue(MaxTextNetzwerkNr);
		
		}
		else
			statusbar->message(i18n("You cannot delete the first network !"),3000);
	}
	else
		statusbar->message(i18n("You must first load or create a unit.  e.g. ob1"),7000);
}//ENDE loescheNetzwerk_clicked()

void ksps::NetzwerkTextToEditor(int Netzwerk)
{  char StrAusschnitt[256];
	char *pChar;
	NetzwerkTitelEditor->clear();
	StrAusschneiden(Netzwerk_Text[Netzwerk],'#','\n',StrAusschnitt);
	NetzwerkTitelEditor->setText(StrAusschnitt);
	pChar=strchr(Netzwerk_Text[Netzwerk],'#');
	if(pChar) //wenn Netzwerk Ueberschrift 
	{  pChar=strchr(Netzwerk_Text[Netzwerk],'\n');
		if(pChar) // Anfang Programmtext
			Editor->setText((pChar+1));
	}
	else
		Editor->setText(Netzwerk_Text[Netzwerk]);  
}//ENDE NetzwerkTextToEditor(int Netzwerk)


void ksps::Editor_InNertwerkTextRetten(int TextNetzwerkNr)
{  char CStr[256],Str[256];
	char *pChar;
	if(TextNetzwerkNr>0)
	{    	NetzwerkText_SeicherAnfrodern(TextNetzwerkNr,ANZAHL_NETZWERK_SPEICHER);
			strcpy(CStr,NetzwerkTitelEditor->text()); // <---<< Editor
  			sprintf(Str,"\t#%s\n",CStr);
			strcpy(CStr_zwischenSpeicher,Str);
			strcat(CStr_zwischenSpeicher,Editor->text());
   		// Zeileumbruch anfuegen wenn nicht vorhanden
			pChar=strchr(CStr_zwischenSpeicher,'\0');
			if(pChar!=NULL)
			{	pChar--;
				pChar=strchr(pChar,'\n');
				if(pChar==NULL)
					strcat(CStr_zwischenSpeicher,"\n");
			}
			LeerzeilenEntfernen(CStr_zwischenSpeicher);
		   strcpy(Netzwerk_Text[TextNetzwerkNr],CStr_zwischenSpeicher);
		}
}//ENDE Editor_InNertwerkTextRetten(int TextNetzwerkNr)


void ksps::BefehlsTabelle()
{	char *Token;
 	int unsigned Zeile,n,Spalte; 
  	const int StrLaegne=256;
  	char DDT[100][StrLaegne];
  	n=0;
	strcpy(DDT[n++],i18n("U|E/A/M/T/Z|NEIN|JA|NEIN|UND-Verknuepfung|U  E 1.4|"));
  	strcpy(DDT[n++],i18n("UN|E/A/M/T/Z|NEIN|JA|NEIN|UND-NICHT-Verknuepfung|UN M 1.0|")); 
  	strcpy(DDT[n++],i18n("O|E/A/M/T/Z|NEIN|JA|NEIN|ODER-Verknuepfung|O  T  1|")); 
  	strcpy(DDT[n++],i18n("ON|E/A/M/T/Z|NEIN|JA|NEIN|ODER-NICHT-Verknuepfung|ON A 1.4|")); 
  	strcpy(DDT[n++],i18n("O|NEIN|NEIN|JA|JA|ODER-Verknuepfung von UND-Ausdruecken|O|")); 
   strcpy(DDT[n++],i18n("U(|NEIN|NEIN|JA|JA|UND-Verknuepfung von Klammerausdruecken|U(|")); 
   strcpy(DDT[n++],i18n("O(|NEIN|NEIN|JA|JA|ODER-Verknuepfung von Klammerausdruecken|O(|")); 
   strcpy(DDT[n++],i18n(")|NEIN|NEIN|JA|NEIN|Ende eines Klammerausdrucks|)|")); 
   
/******* Speicheroperationen *******/	
 strcpy(DDT[n++],i18n("S|E/A/M|JA|NEIN|JA|Setzt den Operanden auf logisch 1|S  M 0.1"));
 strcpy(DDT[n++],i18n("R|E/A/M|JA|NEIN|JA|Setzt den Operanden auf logisch 0|R  M 0.7|"));
 strcpy(DDT[n++],i18n("=|E/A/M|JA|NEIN|JA|Dem Operanden wird der Wert des VEK zugewiesen|=  A 0.3|"));
/******* Ladeoperationen ********/	 	
 strcpy(DDT[n++],i18n("L|EB/AB/MB|NEIN|NEIN|NEIN|Ein Byte wird in den Akku 1 geladen|L  EB 2|"));
 strcpy(DDT[n++],i18n("L|EW/AW/MW|NEIN|NEIN|NEIN|Ein Word wird in den Akku 1 geladen|L  MW 128|"));
 strcpy(DDT[n++],
	i18n("L|KB|NEIN|NEIN|NEIN|Ein Konstante (1-Byte-Zahl) wird in den Akku1 geladen|L  KB 215|"));
strcpy(DDT[n++],
	i18n("L|KF|NEIN|NEIN|NEIN|Ein Konstante (Festpunkzahl) wird in den Akku1 geladen|L  KF 4711|"));
strcpy(DDT[n++],
	i18n("L|KH|NEIN|NEIN|NEIN|Ein Konstante im Hexalsystem wird in den Akku1 geladen |L  KH CAFE|"));
strcpy(DDT[n++],
	i18n("L|KY|NEIN|NEIN|NEIN|Eine Konstante (2-Byte-Zahl) wird in den Akku1 geladen|L  KY 123,214|"));
strcpy(DDT[n++],
	i18n("L|KT|NEIN|NEIN|NEIN|Ein Zeitwert wird BCD-Codiert in den Akku1 geladen|L  KT 125.2|"));
strcpy(DDT[n++],
	i18n("L|KZ|NEIN|NEIN|NEIN|Ein Zaehlerwert wird BCD-Codiert in den Akku1 geladen|L  KZ 231|"));
strcpy(DDT[n++],
	i18n("L|Z/T|NEIN|NEIN|NEIN|Ein Zeit- oder Zaehler- Istwert wird in den Akku1 geladen |L  Z 10|"));
strcpy(DDT[n++],
	i18n("LC|Z/T|NEIN|NEIN|NEIN|Ein Zeit- oder Zaehler- Istwert wird BCD-Codiert in den Akku1"
	" geladen |LC T 7|"));
/******* Transferbefehle *******/	
strcpy(DDT[n++],
	i18n("T|EB/AB/MB|NEIN|NEIN|NEIN|Der Inhalt des Akku1 (Lowbyte) wird in ein Byte geschrieben|T AB 7|"));
strcpy(DDT[n++],
	i18n("T|EW/AW/MW|NEIN|NEIN|NEIN|Der Inhalt des Akku1 wird in ein Wort geschrieben|T AW 10|"));
/******** Timer Befehle	********/
strcpy(DDT[n++],
	i18n("SI|T|X0>1|NEIN|JA|Eine Zeit die in den Akku1 abgelegt wurde, wird als Impuls gestartet"
		  "|SI T 15|"));
strcpy(DDT[n++],
	i18n("SV|T|X0>1|NEIN|JA|Eine Zeit die in den Akku1 abgelegt wurde, wird als verlaengerter"
		  " Impuls gestartet|SV T5|"));
strcpy(DDT[n++],
	i18n("SE|T|X0>1|NEIN |JA|Eine Zeit die in den Akku1 abgelegt wurde, wird als einschaltverzoegert"
		  "gestartet|SE T 17|"));
strcpy(DDT[n++],i18n("SS|T|X0>1|NEIN |JA|Wie SE nur speichernd|SS T 112|"));
strcpy(DDT[n++],
	i18n("SA|T|X1>0|Nein|Ja|Eine Zeit die in den Akku1 abgelegt wurde,wird ausschaltverzoegert gestartet"
 		  "|SA T 110|"));
strcpy(DDT[n++],i18n("R|T|X=1|Nein|Ja|Eine Zeit wird rueckgesetzt |R T 1|"));
/****** Zaehler Befehle *******/ 	
	strcpy(DDT[n++],i18n("ZV|Z|X0>1|Nein|Ja|Zaehler um 1 erhoehen |ZV Z 5|"));
	strcpy(DDT[n++],i18n("ZR|Z|X0>1|Nein|Ja|Zaehler um 1 erniedrigen |ZR Z 127|"));
 	strcpy(DDT[n++],i18n("S|Z|X0>1|Nein|Ja|Setzt den Zaehler auf einen Wert, der im Akku1 BCD-kodiert"
							   "hinterlegt ist|R Z 25|"));
	strcpy(DDT[n++],i18n("R|Z|X=1|Nein|Ja|Einen Zaehler ruecksetzten |R Z 25|"));
	
/****** Arithmetische Befehle *******/	
strcpy(DDT[n++],
	i18n("+F|NEIN|NEIN|NEIN|NEIN|Zwei Festpunktzahlen werden addiert. Akku1 + Akku2.Das Ergebnis steht im"
		  "Akku1|+F|"));
strcpy(DDT[n++],
	i18n("-F|NEIN|NEIN|NEIN|NEIN|Zwei Festpunktzahlen werden subtrahiert. Akku1 - Akku2.Das Ergebnis" 
        " steht im"
			  "Akku1|-F|"));
strcpy(DDT[n++],i18n("*F|NEIN|NEIN|NEIN|NEIN|Zwei Festpunktzahlen werden multipliziert."
								" Akku1 * Akku2.Das Ergebnis steht im Akku1|*F|"));
strcpy(DDT[n++],
		i18n(	"/F|NEIN|NEIN|NEIN|NEIN|Zwei Festpunktzahlen werden dividiert. Akku1 / Akku2."
				"Das Ergebnis steht im Akku1|/F|"));

/******* Vergleichsoperationen ********/
	strcpy(DDT[n++],
		i18n(	"!=F|NEIN|NEIN |JA|NEIN |Wenn Akku1=Akku2  dann wird das VEK=1|!=F|"));
	strcpy(DDT[n++],
		i18n(	"><F|NEIN|NEIN|JA|NEIN |Wenn Akku1 nicht gleich Akku2  dann wird das VEK=1|><F|"));
	strcpy(DDT[n++],
		i18n(	">F|NEIN|NEIN|JA|NEIN |Wenn Akku2 groesser Akku1  dann wird das VEK=1|>F|"));
	strcpy(DDT[n++],
		i18n(	">=F|NEIN|NEIN|JA|NEIN|Wenn Akku2 >= Akku1  dann wird das VEK=1|>=F|"));
	strcpy(DDT[n++],
		i18n(	"<F|NEIN|NEIN|JA|NEIN|Wenn Akku2 < Akku1  dann wird das VEK=1|<=F|"));
	strcpy(DDT[n++],
		i18n(	"<=F|NEIN|NEIN|JA|NEIN|Wenn Akku2 <= Akku1  dann wird das VEK=1|<=F|"));

/***** Bausteinaufrufoperationen ******/ 	
	strcpy(DDT[n++],
		i18n("SPA|OB/PB/FB/SB|Nein|Nein|Ja|Programmbaustein aubslut aufrufen|SPA PB2|"));
	strcpy(DDT[n++],
		i18n("SPB|OB/PB/FB/SB|X=1|X#1|JA|Programmbaustein bedingt aufrufen|SPB FB10|"));
/**** Ruecksprungoperationen ******/	
	strcpy(DDT[n++],i18n("BE|Nein|Nein|Nein|Ja|Baustein beebden|BE|"));
	strcpy(DDT[n++],i18n("BEB|Nein|X=1|Nein|X#1|Baustein bedingt beenden|BEB|"));
	strcpy(DDT[n++],i18n("BEA|NEIN|Nein|Nein|Ja|Baustein wird absolute beendet|BEA|"));

/******  Null Operaqtionen *******/
	strcpy(DDT[n++],i18n("NOP0|Nein|Nein|Nein|Nein|Dient als Platzhalter|NOP0|"));
	strcpy(DDT[n++],i18n("NOP1|Nein|Nein|Nein|Nein|Nulloperation: hat keine Bedeutung|NOP1"));
	
/****** Umwandlungsoperation *******/	
strcpy(DDT[n++],i18n("KEW|Nein|Nein|Nein|Nein|Das 1er-Komplement (Negierung) von Akku1 bilden|KEW"));
strcpy(DDT[n++],
i18n("KZW|Nein|Nein|Nein|Nein|Das 1er-Komplement (Negierung) von Akku1 bilden und 1 dazu addieren|KZW"));
	
/******* Schiebeoperationen ******/		
	strcpy(DDT[n++],i18n("SLW|Nein|Nein|Nein|Nein|Inhalt von Akku1 um 1 Bit nach links schieben|SWL"));
	strcpy(DDT[n++],i18n("SRW|Nein|Nein|Nein|Nein|Inhalt von Akku1 um 1 Bit nach rechts schieben|SRW"));

/***** Aritmetische Operationen ******/		
	strcpy(DDT[n++],
		i18n("ADD|BF|Nein|Nein|Nein|Eine 1-Byte Konstante zum  Akku1 addieren (-128...+127)|ADD BF 123"));
	strcpy(DDT[n++],
		i18n("ADD|KF|Nein|Nein|Nein|Eine 2-Byte Konstante zum  Akku1 addieren (-32768...+32767)|ADD KF -31123"));
	strcpy(DDT[n++],i18n("D|Nein|Nein|Nein|Nein|Das Low-Byte von Akku1 um 1 (0..255) erniedrigen |D"));
	strcpy(DDT[n++],i18n("I|Nein|Nein|Nein|Nein|Das Low-Byte von Akku1 um 1 (0..255) erhoehen |I"));

/****** Sonstige Operationen ********/	
	strcpy(DDT[n++],i18n("TAK|Nein|Nein|Nein|Nein|Der Inhalt von Akku1 und Akku2 wird vertauscht|TAK"));
	strcpy(DDT[n++],
		i18n("UW|Nein |Nein|Nein|Nein|UND-Verknuepfung von Akku1 und Akku2 das Ergebniss im Akku1|UW"));
	strcpy(DDT[n++],i18n("OW|Nein|Nein|Nein|Nein|ODER-Verknuepfung von Akku1 und Akku2 das Ergebniss"
								"im Akku1|OW"));
	strcpy(DDT[n++],
		i18n("XOW|Nein|Nein|Nein|Nein|EXKLUSIV-ODER-Verknuepfung von Akku1 und Akku2 das Ergebniss im Akku1|XOW"));
	strcpy(DDT[n++],
		i18n("DUF|Nein|Nein|Nein|Nein|DUAL (Akku1) ==> BCD (Akku1)|DUF"));
	strcpy(DDT[n++],
		i18n("DEF|Nein|Nein|Nein|Nein|BCD (Akku1) ==> DUAL (Akku1)|DEF"));	

 	for(Zeile=0;Zeile<n;Zeile++)						
	{	Token=strtok(DDT[Zeile],"|");
		Spalte=0;
		while(Token != NULL)
		{  pTabelle->setText(Zeile,Spalte,Token); 
			
			Spalte++;	
			Token=strtok(NULL,"|");
		}						
		//pTabelle->setRowReadOnly (Zeile,true); 
	}
	pTabelle->setReadOnly(true);
}// ENDE BefehlsTabelle()



void ksps::getTabellenKommentarEAMTZ()
{	int Zeile,Spalte;  
 	QString QStr;
	for(Spalte=0;Spalte<=2;Spalte++)
	{	for(Zeile=0;Zeile<=255;Zeile++) 
		{	QStr=pEAM_KommentarTabelle->text(Zeile,Spalte);
			switch(Spalte)
			{	case 0:
					if(QStr.length()>0)
						strcpy(pEingaenge_Kommentar[Zeile],QStr);
					else
						*pEingaenge_Kommentar[Zeile]=0;
				break;
				case 1:
					if(QStr.length()>0)
						strcpy(pAusgaenge_Kommentar[Zeile],QStr);
					else
						*pAusgaenge_Kommentar[Zeile]=0;
				break;
				case 2:
					if(QStr.length()>0)
						strcpy(pMerker_Kommentar[Zeile],QStr);
					else
						*pMerker_Kommentar[Zeile]=0;
				break;
			}//ENDE switch(Spalte)
			QStr=pTZ_ObPbFbSbKommentarTabelle->text(Zeile,Spalte);	
			switch(Spalte)	
			{	case 0:	
					if(QStr.length()>0)
						strcpy(pTimer_Kommentar[Zeile],QStr);
					else
						*pTimer_Kommentar[Zeile]=0;	
				break;
				case 1:	
					if(QStr.length()>0)
						strcpy(pZaehler_Kommentar[Zeile],QStr);
					else
						*pZaehler_Kommentar[Zeile]=0;	
				break;
			}//ENDE switch(Spalte)		
		}//ENDE for(Zeile=0;Zeile<=255;Zeile++) 
	}//ENDE for(Spalte=0;Spalte<=2;Spalte++)
}//ENDE void ksps::getKommentarEAMTZ()

void ksps::setTabellenKommentarEAMTZ()
{	int Zeile; 
	for(Zeile=0;Zeile<=255;Zeile++) 
	{	pEAM_KommentarTabelle->setText(Zeile,0,pEingaenge_Kommentar[Zeile]);
		pEAM_KommentarTabelle->setText(Zeile,1,pAusgaenge_Kommentar[Zeile]);
		pEAM_KommentarTabelle->setText(Zeile,2,pMerker_Kommentar[Zeile]);
		pTZ_ObPbFbSbKommentarTabelle->setText(Zeile,0,pTimer_Kommentar[Zeile]);
		pTZ_ObPbFbSbKommentarTabelle->setText(Zeile,1,pZaehler_Kommentar[Zeile]);
		pTZ_ObPbFbSbKommentarTabelle->setText(Zeile,2,pOB_Kommentar[Zeile]);
		pTZ_ObPbFbSbKommentarTabelle->setText(Zeile,3,pPB_Kommentar[Zeile]);
		pTZ_ObPbFbSbKommentarTabelle->setText(Zeile,4,pFB_Kommentar[Zeile]);
		pTZ_ObPbFbSbKommentarTabelle->setText(Zeile,5,pSB_Kommentar[Zeile]);
	}
}//ENDE void ksps::setTabelleKommentarEAMTZ()

void ksps::TabWidget_slot(QWidget *pTW)
{  int	index=TabWidget->indexOf(pTW);
   if(index==1)
	{	AnzeigeTimer->start(1,true);
	}
}//ENDE void ksps::TabWidget_slot(QWidget *pTW)

void ksps::TZTabelle_slot(int Zeile,int Spalte)
{	QString QStr;
	QStr=pTZ_ObPbFbSbKommentarTabelle->text(Zeile,Spalte);
  	switch(Spalte)
  	{	case 0:
  			if(QStr.length()>0)
				strcpy(pTimer_Kommentar[Zeile],QStr);
			else
				*pTimer_Kommentar[Zeile]=0;
		break;
  		case 1:
  			if(QStr.length()>0)
				strcpy(pZaehler_Kommentar[Zeile],QStr);
			else
				*pZaehler_Kommentar[Zeile]=0;
		break;
		case 2:
  			if(QStr.length()>0)
				strcpy(pOB_Kommentar[Zeile],QStr);
			else
				*pOB_Kommentar[Zeile]=0;
		break;
		case 3:
  			if(QStr.length()>0)
				strcpy(pPB_Kommentar[Zeile],QStr);
			else
				*pPB_Kommentar[Zeile]=0;
		break;
		case 4:
  			if(QStr.length()>0)
				strcpy(pFB_Kommentar[Zeile],QStr);
			else
				*pFB_Kommentar[Zeile]=0;
		break;
		case 5:
  			if(QStr.length()>0)
				strcpy(pSB_Kommentar[Zeile],QStr);
			else
				*pSB_Kommentar[Zeile]=0;
		break;
	}
}//ENDE void ksps::TZTabelle_slot(int Zeile,int Spalte)

void ksps::EAMTabelle_slot(int Zeile,int Spalte)
{ QString QStr;
  QStr=pEAM_KommentarTabelle->text(Zeile,Spalte);
  switch(Spalte)
  {	case 0:
  			if(QStr.length()>0)
				strcpy(pEingaenge_Kommentar[Zeile],QStr);
			else
				*pEingaenge_Kommentar[Zeile]=0;
		break;
  		case 1:
  			if(QStr.length()>0)
				strcpy(pAusgaenge_Kommentar[Zeile],QStr);
			else
				*pAusgaenge_Kommentar[Zeile]=0;
			break;
  		case 2:
  			if(QStr.length()>0)
				strcpy(pMerker_Kommentar[Zeile],QStr);
			else
				*pMerker_Kommentar[Zeile]=0;
		break;
  }	
}//ENDE void ksps::EAMTabelle_slot(int Zeile,int Spalte)

void ksps::getTimeSlider(int Zeit_ms)
{  SimulationAlle_ms=Zeit_ms;
   if(SPS_RUN==true)
	{	SimulationsTimer->stop();
		SimulationsTimer->start(SimulationAlle_ms,false);
	}
}

void ksps::PauseButton_pressed()
{ if(SPS_RUN==true)
	{ SimulationsTimer->stop();
		WorkThread.aktiv=false;
	}
}

void ksps::PauseButton_released()
{	if(SPS_RUN==true)
	{ SimulationsTimer->start(SimulationAlle_ms,false);
 	  SPS_ProgrammAufrufen_Timer();
	  WorkThread.aktiv=true;
	}
}

void ksps::FehlerListBox_slot(int index)
{ char CStr[256];
  char *pChar;
  int NetzwerkNr,ZeileNr,lenStr;
 	strcpy(CStr,FehlerListBox->text(index));
	pChar=strchr(CStr,':');
	pChar++;
	while(*pChar==' ') pChar++; 
	NetzwerkNr=atoi(pChar);
	pChar=strchr(pChar,':');
	pChar++;
	while(*pChar==' ') pChar++; 
	ZeileNr=atoi(pChar)-1;
	lenStr=Editor->length();
	if(lenStr==0)
	{	get_spinBox_text_NeNr_slot(NetzwerkNr);
	}
	else if(TextNetzwerkNr!=NetzwerkNr)
	{ Editor_InNertwerkTextRetten(TextNetzwerkNr);
	  get_spinBox_text_NeNr_slot(NetzwerkNr);
	}  
   Editor->setSelectionAttributes (1,QColor(255,0,0),false);
	Editor->setSelection (ZeileNr,0,ZeileNr,lenStr,1); 
} //ENDE FehlerListBox_slot(int index)

void ksps::loescheFehlerListBoxl_clicked()
{	FehlerListBox->clear();
}


void ksps::ProjektlLadenToAgUStarten(QString BeispielPfad)
{	int n;
	if(ProjektLaden(BeispielPfad))
	{	SpsTextLaden(QProjektpfad+"ob1.sps");
		for(n=8;n<=15;n++)
		{	PushButton_EBit[n]->setOn(false);
			ButtonGroupEB1_Toggle(n-8);
		}
		AG_Loeschen();
		if(strcmp(Projekt_Kennung,PROJEKT_KENNUNG)==0)
		{	Alle_Bausteine_ins_AG_laden();
			AnzeigeTimer->start(1,true);
			StartStopButton_Rb(1); //Start
		}
		else
			statusbar->message(i18n("Konnte Projekt nicht Laden!"),5000);
	}	
	else
		statusbar->message(i18n("Konnte Projekt nicht Laden!"),5000);
}

/*
	char AusgabeCounter[80];
	sprintf(CounterCStr,"%1.0f\n",miliSekunden_double);
 	n=strlen(CounterCStr);
	sprintf(AusgabeCounter,"msCounter :%s\n",CounterCStr);
	statusbar->message(AusgabeCounter);
//*/
