#include  "ttySn.h"
/*
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
*/

//	BAUDRATE B1200, B2400, B4800, B9600, B19200, B38400, B57600, B115200

//#define _POSIX_SOURCE 1


ttySn::ttySn()
{	fd=0;
	res=0;
	strcpy(Code_init_Modem,"AT S7=45 S0=11 L3 V1 X4 &c1 E1 Q0 M1 \r");
	strcpy(Code_waehlen,"AT DT ");
	strcpy(Code_auflegen,"AT H0\r");
	strcpy(Code_abheben,"AT H1\r");
	strcpy(Code_antworten,"AT A\r");
	
}//ENDE ttySn()

ttySn::~ttySn(void)
{ if (fd>0)
  {   tcsetattr(fd,TCSANOW,&oldtio);
  	   close(fd);
  	   fd=0;
      usleep(100000);
  }
}
//-------------------------------------------------------------------------------------------------
int ttySn::Open_ttySn(int dev_ttySNr,speed_t Baudkonstante)
{	if (fd!=0) return false;
	switch(dev_ttySNr)
	{ 	case dev_ttyS0:
			fd=open("/dev/ttyS0",O_RDWR | O_NOCTTY);
			if	(fd<0)	{perror("/dev/ttyS0"); exit(-1);}
   		break;
		case dev_ttyS1:
			fd=open("/dev/ttyS1",O_RDWR | O_NOCTTY);
			if	(fd<0)	{perror("/dev/ttyS1"); exit(-1);}
   		break;
   	case dev_ttyS2:
			fd=open("/dev/ttyS2",O_RDWR | O_NOCTTY);
			if	(fd<0)	{perror("/dev/ttyS2"); exit(-1);}
   		break;
   	case dev_ttyS3:
			fd=open("/dev/ttyS3",O_RDWR | O_NOCTTY);
			if	(fd<0)	{perror("/dev/ttyS3"); exit(-1);}
   		break;

   }
	tcgetattr(fd,&oldtio);
	memset(&newtio,0,sizeof(newtio));

   // CS8 			8Bit senden u. empfangen
   // CREAD			Empfangen vo Zeichen soll aktiviert werden
   // CLOCAL   	Alle Modemleitungen sollen ignoriert werden
   // CRTSSCTS    RTS / CTS Ful�ontrolle
   // HUPCL			Beim schlie�n soll das Modem auflegen
   newtio.c_cflag=Baudkonstante | CS8 | CREAD | CLOCAL | CRTSCTS | HUPCL;
   newtio.c_iflag=0;//IGNPAR;
	newtio.c_oflag=OPOST;
	newtio.c_lflag=0;
	newtio.c_cc[VTIME]=0;
	newtio.c_cc[VMIN]=0;

	tcflush(fd,TCIOFLUSH);
	tcsetattr(fd,TCSANOW,&newtio);
	return fd;
}

void ttySn::close_ttySn(void)
{ if (fd>0)
  {   tcsetattr(fd,TCSANOW,&oldtio);
  	   close(fd);
  	   fd=0;
      usleep(100000);
  }
}

int ttySn::Empfangen(char *EDaten,int laenge)
{ if (fd>0)
  {	res = read(fd,EDaten,laenge);
		EDaten[res]=0;
		return res;
  }
  return 0;
}

int ttySn::Senden(const char *SDaten,int laenge)
{  if (fd>0)
	{  res=write(fd,SDaten,laenge);
		return res;
	}
	return 0;

}

void ttySn::waehlen_Modem(char *StrNummer)
{ char StrWaehlenNummer[256];
  if(fd>0)
  { 	strcpy(StrWaehlenNummer,Code_waehlen);
  		strcat(StrWaehlenNummer,StrNummer);
  		strcat(StrWaehlenNummer,"\r");
  		Senden(StrWaehlenNummer,strlen(StrWaehlenNummer));
  }
}

void ttySn::abheben_Modem()
{  if(fd>0)
		 Senden(Code_abheben,strlen(Code_abheben));
}

void ttySn::antworten_Modem()
{   if(fd>0)
		 Senden(Code_antworten,strlen(Code_antworten));
}

void ttySn::auflegen_Modem()
{  if(fd>0)
		Senden(Code_auflegen,strlen(Code_auflegen));

}

int ttySn::senden_Modem(const char *SDaten)
{ 	if(fd>0)
		return Senden(SDaten,strlen(SDaten));
	return 0;
}

int ttySn::empfangen_Modem(char *EDaten)
{   if(fd>0)
		 return Empfangen(EDaten,255);
	return 0;
}

